#!/usr/local/bin/perl

if ($ENV{'REQUEST_METHOD'} eq 'GET') 
{ 
   @pairs = split(/&/,$ENV{'QUERY_STRING'}); 
}
elsif ($ENV{'REQUEST_METHOD'} eq 'POST') 
{  
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   
   if($ENV{QUERY_STRING}) 
   {
      @getpairs = split(/&/,$ENV{'QUERY_STRING'});
      push(@pairs,@getpairs);
   }
}

foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $FORM{$name} = $value;
}

$relativer_pfad = $FORM{'pfd'};
$neuesdok = $FORM{'neuesdok'};

# Berechtigung checken und @filenamen ermitteln 
require 'verz_check.cgi';
&berechtigung_checken($relativer_pfad); 

if ($neuesdok eq "1") 
{ 
   $vorschlag = "NeuesDokument.txt"; 
   $alsString = "";
   $titel ="Neues Text-Dokument editieren";
   $jj = $titel;
}   
else 
{
   $neu = $FORM{'neu'};
   $neu =~ s/^\.+//;  # Punkte am Anfang werden weggezwickt

   foreach $j (@filenamen) 
   {
      if ($j eq $FORM{'fl'}) 
      {  
         $vorschlag = $j;
         $betreffendedatei = "$relativer_pfad/$j"; 
         $titel = "Datei $j editieren";
         $jj = "Datei <B>$j</B> editieren";
      }
   }
}

# falls die eingegebene Datei im betreffenden Verzeichnis liegt:

  if (($neuesdok ne "1") && (-e $betreffendedatei))   
   { 
    
   # Letztere nderungszeit bestimmen fr sptere berschreibwarnung in speichern
   $zeit = (stat("$betreffendedatei"))[9];

   
   open(FILE_LES,$betreffendedatei);
   flock(FILE_LES, 2);
   @dateiinhalt = <FILE_LES>;
   flock(FILE_LES, 8);
   close(FILE_LES);
   $alsString = "";   
   foreach $zeile (@dateiinhalt) { $alsString = $alsString.$zeile; }     
   
   $alsString =~ s/\&/\&amp\;/g;   # um nderungen des Texts durch die Darstellung
                                  # im Formular auf der Web-Seite zu verhindern
   
   }

   print "Content-type: text/html\n\n";
      
   print <<"LABEL_ANZEIGE";
      <HTML>
      <HEAD><TITLE>$titel</TITLE></HEAD>
	  <SCRIPT LANGUAGE="JavaScript">
	  function sonderzeichen_checken()
	  {
	   if (nichtokay(document.forms[0].fl.value))
	   {
	     anfeinf = "'"; anfdopp = '"';
	     txt = "Bitte ndern Sie den eingegebenen Dateinamen! " +
	           "Der neue Name sollte die Zeichen &, +, ?, ; , %, #, =, " + anfdopp +
	  		 ' und ' + anfeinf + " nicht enthalten und nicht mit 'index' beginnen.";
	  	//	 "und keinen Schrgstrich am Ende haben.";
	     alert(txt);
	     return false;
	   } 
	   else return true;
	  }
	  function nichtokay(nam)
	  {
	   if ( (nam == "") || (nam.indexOf('&') != -1) || (nam.indexOf('+') != -1) ||
	         (nam.indexOf('?') != -1) || (nam.indexOf(';') != -1) ||
	         (nam.indexOf('%') != -1) || (nam.indexOf("\'") != -1) ||
	  	   (nam.indexOf('%') != -1) || (nam.indexOf('#') != -1) ||
	  	   (nam.indexOf('=') != -1) || (nam.indexOf('\"') != -1) 
	  	   || (nam.indexOf('index') == 0)    
	  	   || ( (nam.indexOf('.') == 0) && (nam.indexOf('index') == 1 )	)  
	    // komisch: das haut nicht hin
	    //   || (nam.indexOf('/') == nam.length - 1)
	       )
	   return true;
	   else return false;
	  }
      </SCRIPT>
      <BODY LINK="#0000CC" VLINK="#000099" ALINK="#009999">
	  <FORM ACTION="speichern.cgi" METHOD="POST" 
	  ONSUBMIT="if (sonderzeichen_checken()) 
	  { window.opener.schliessen=0; return true; } else return false;"><INPUT
	  TYPE="hidden" NAME="pfd" VALUE="$relativer_pfad"
	  ><INPUT TYPE="hidden" NAME="zeit" VALUE="$zeit"><INPUT 
	  TYPE="hidden" NAME="neuesdok" VALUE="$neuesdok"><INPUT
	  TYPE="hidden" NAME="original" VALUE="$vorschlag"><CENTER><BR>
	  <TABLE WIDTH="95%" BORDER="0" CELLPADDING="0" CELLSPACING="0"><TD WIDTH="40%" ALIGN="center"
	  ><FONT FACE="Arial,Helvetiva" SIZE="-1">$jj</FONT
	  ></TD><TD WIDTH="60%" ALIGN="right"
	  ><NOBR><FONT FACE="Arial,Helvetiva" SIZE="-1">Als</FONT>&nbsp;
	  <INPUT TYPE="text" NAME="fl" SIZE="25" VALUE="$vorschlag"
	  >&nbsp;(<INPUT TYPE="checkbox" NAME="ueberschreiben"
	  >&nbsp;<FONT FACE="Arial,Helvetiva" SIZE="-1">&uuml;ber-</FONT
	  >)&nbsp;<FONT FACE="Arial,Helvetiva" SIZE="-1"><INPUT TYPE="submit" VALUE="schreiben"
	  ></FONT>&nbsp;&nbsp;</NOBR></TD></TABLE><BR>
	  <TEXTAREA NAME="editfile" COLS="88" ROWS="22"
	  >$alsString</TEXTAREA>
      </CENTER></FORM><SCRIPT LANGUAGE="JavaScript"
      >if (document.forms[0]) document.forms[0].editfile.focus();</SCRIPT
      ></BODY></HTML>
LABEL_ANZEIGE


sub gibts_checken
{
    $gibts = "nein";
    foreach $f (@filenamen) 
    {
       if ($f eq $_[0]) { $gibts = "ja"; }
    }	
    return $gibts;
}
