#!/usr/local/bin/perl

if ($ENV{'REQUEST_METHOD'} eq 'GET') 
{ 
   @pairs = split(/&/,$ENV{'QUERY_STRING'}); 
}
elsif ($ENV{'REQUEST_METHOD'} eq 'POST') 
{  
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   
   if($ENV{QUERY_STRING}) 
   {
      @getpairs = split(/&/,$ENV{'QUERY_STRING'});
      push(@pairs,@getpairs);
   }
}

foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $FORM{$name} = $value;
}

$relativer_pfad = $FORM{'pfd'};

# Berechtigung checken und @filenamen ermitteln 
require 'verz_check.cgi';
&berechtigung_checken($relativer_pfad); 

$url = &entf("$scriptverzeichnis/$relativer_pfad"); 

   print "Content-type: text/html\n\n";
      
   print <<"LABEL_HTML";
<HTML>
<HEAD><TITLE>Hilfe: Dateien am Server speichern</TITLE></HEAD>
<BODY LINK="#0000CC" VLINK="#000099" ALINK="#009999">
<FONT FACE="Arial,Helvetica" SIZE="-1">

<CENTER><BR><BR>
<FONT SIZE="+0"><B>Dateien am Server speichern</B></FONT>
</CENTER><BR><BR>

<UL>
<LI>Dateien werden in das Verzeichnis<BR>
<CENTER><BR>
$url/
</CENTER><BR>
&uuml;bertragen und unter demselben Namen gespeichert, den sie auf Ihrem
Computer haben. Sie k&ouml;nnen sie <I>danach</I> umbenennen.<BR>&nbsp;

<LI>
Aus Sicherheitsgr&uuml;nden d&uuml;rfen Dateinamen nicht mit 'index' und nicht
mit einem Punkt beginnen. (Ersteres wird abgelehnt, ein Punkt wird ignoriert).
Dateinamen sollten - au&szlig;er in der Pfadangabe -  
keine Schr&auml;gstriche (&nbsp;/ und &#92;&nbsp;) enthalten.
<B>Sonderzeichen</B> wie Anf&uuml;hrungszeichen (&nbsp;" und '&nbsp;) 
und die Symbole &amp;, +, ?, ;, %, # und = werden abgelehnt.
Leerzeichen werden durch das Symbol _ ersetzt.<BR>&nbsp;

<LI>
Alle Dateien gemeinsam
d&uuml;rfen gemeinsam nicht gr&ouml;&szlig;er als 1 MB sein.<BR>&nbsp;
<LI>
<B>Achtung</B>: Falls bereits eine Datei gleichen Namens existiert, so
wird sie <B>nicht &uuml;berschrieben</B>. In diesem Fall wird dem Namen der
<B>neuen</B> Datei eine Tilde (~) vorangestellt.<BR>
Beispiel: Liegt eine Datei namens&nbsp;
<FONT FACE="Courier" SIZE="-1">Notizen.doc</FONT>&nbsp; am Server, und
wird eine Datei gleichen Namens abgeschickt, so wird diese unter dem Namen&nbsp;
<FONT FACE="Courier" SIZE="-1">~Notizen.doc</FONT>&nbsp; gespeichert.<BR>
Auch gleichnamige abgeschickte Dateien aus verschiedenen Verzeichnissen
werden durch eine vorangestellte Tilde unterschieden.<BR>&nbsp;

<LI>Falls Sei einen <B>&auml;lteren Browser</B> benutzen (z.B. Netscape Navigator&nbsp;3),
so kann eine ungerechtfertigte Ablehnung des Dateinames aufgrund von 
Sonderzeichen, die gar nicht vorkommen, geschehen. In diesem Fall
tippen Sie mit dem Cursor einfach in das Textfeld, in dem der Pfad der Datei steht
(ohne den Text zu &auml;ndern), und klicken Sie dann erneut auf den Button 'Speichern'!
</UL>

</FONT>
</BODY>
</HTML>
LABEL_HTML

sub entf
{
    # Strukturen vom Typ /A/.. aus URLs entfernen
    @teile = split(/\//,$_[0]);
    for ($i=0; $i<@teile; $i++)
    {
         if ($teile[$i] eq "..")
   	  {
   	     $teile[$i] = "";
   	     $kindex = 1;
	     while (($teile[$i-$kindex] eq "") && ($i-$kindex>1))  # letzteres verhindert Endlosschleife
	     { 
	       $kindex = $kindex + 1;   # Index des letzten nichtleeren Teils
	     }
	     $teile[$i-$kindex] = "";  # den letzten Teil, der nicht leer ist, entfernen,
	                               # um auch Strukturen wie A/../../B zu erfassen
	  }
    }
    $url_aux="";
    foreach $k (@teile)  { $url_aux = "$url_aux/$k"; }
    $url_aux =~ s/\/http/http/;
    while ($url_aux =~ /\/\//)
    { $url_aux =~ s/\/\//\//; }    # Mehrfach-Slashes entfernen
    $url_aux =~ s/http:\//http:\/\//;
    return $url_aux;
}
