#!/usr/local/bin/perl

if ($ENV{'REQUEST_METHOD'} eq 'GET') 
{ 
   @pairs = split(/&/,$ENV{'QUERY_STRING'}); 
}
elsif ($ENV{'REQUEST_METHOD'} eq 'POST') 
{  
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   
   if($ENV{QUERY_STRING}) 
   {
      @getpairs = split(/&/,$ENV{'QUERY_STRING'});
      push(@pairs,@getpairs);
   }
}

foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $FORM{$name} = $value;
}

$relativer_pfad = $FORM{'pfd'};
$fl = $FORM{'fl'};
$dv = $FORM{'dv'};

  # Berechtigung checken und @filenamen ermitteln 
  require 'verz_check.cgi';
  &berechtigung_checken($relativer_pfad); 

require "$relativer_pfad/.06641431691"; 

if ($FORM{'head'} eq "ja")     # falls Aufruf das aktuelle Verzeichnis betrifft
{
   $txt = $_titel_{" verz06641431691"};
   print "Content-type: text/html\n\n";
      
   print <<"LABEL_ANZEIGE";
      <HTML>
      <HEAD><TITLE>Titel des aktuellen Verzeichnisses &auml;ndern</TITLE></HEAD>
      <BODY LINK="#0000CC" VLINK="#000099" ALINK="#009999">
	  <FORM ACTION="titeleintragen.cgi" METHOD="POST" ONSUBMIT="{window.opener.schliessen=0;return true;}">
	  <INPUT TYPE="hidden" NAME="pfd" VALUE="$relativer_pfad">
	  <INPUT TYPE="hidden" NAME="head" VALUE="ja">
	  <CENTER>
	  <TABLE WIDTH="95%" BORDER="0"><TD ALIGN="left">
	  <FONT FACE="Arial,Helvetiva" SIZE="-1">
	  Titel des aktuellen Verzeichnisses
	  </FONT></TD></TABLE>
	  <BR>
	  <NOBR><FONT FACE="Arial,Helvetiva" SIZE="-1">zu</FONT>&nbsp;&nbsp;
	  <INPUT TYPE="text" NAME="neuerTitel" SIZE="40" VALUE="$txt">&nbsp;&nbsp;
	  <FONT FACE="Arial,Helvetiva" SIZE="-1"><INPUT TYPE="submit" VALUE="&auml;ndern"></FONT> 
	  </NOBR>
      </CENTER>
	  </FORM>
	  <SCRIPT LANGUAGE="JavaScript">
	  if (document.forms[0]) document.forms[0].neuerTitel.focus();</SCRIPT>	  
	  </BODY></HTML>
LABEL_ANZEIGE

}
else          # falls Aufruf eine Datei oder ein Verzeichnis betrifft
{
  if ($FORM{'dv'} eq "d") 
  { $dvtxt = "der Datei"; }  # falls Verzeichnis
  elsif ($FORM{'dv'} eq "v") { $dvtxt = "des Verzeichnisses"; }  # falls Datei

  
   $txt = $_titel_{$fl};
   print "Content-type: text/html\n\n";
      
   print <<"LABEL_ANZEIGE";
      <HTML>
      <HEAD><TITLE>Titel $dvtxt $fl &auml;ndern</TITLE></HEAD>
      <BODY LINK="#0000CC" VLINK="#000099" ALINK="#009999">
	  <FORM ACTION="titeleintragen.cgi" METHOD="POST" ONSUBMIT="{window.opener.schliessen=0;return true;}">
	  <INPUT TYPE="hidden" NAME="pfd" VALUE="$relativer_pfad">
	  <INPUT TYPE="hidden" NAME="fl" VALUE="$fl">
	  <INPUT TYPE="hidden" NAME="dv" VALUE="$dv">	  
	  <CENTER>
	  <TABLE WIDTH="95%" BORDER="0"><TD ALIGN="left">
	  <FONT FACE="Arial,Helvetiva" SIZE="-1">
	  Titel $dvtxt <B>$fl</B>
	  </FONT></TD></TABLE>
	  <BR>
	  <NOBR><FONT FACE="Arial,Helvetiva" SIZE="-1">zu</FONT>&nbsp;&nbsp;
	  <INPUT TYPE="text" NAME="neuerTitel" SIZE="40" VALUE="$txt">&nbsp;&nbsp;
	  <FONT FACE="Arial,Helvetiva" SIZE="-1"><INPUT TYPE="submit" VALUE="&auml;ndern"></FONT> 
	  </NOBR>
      </CENTER>
	  </FORM>
	  <SCRIPT LANGUAGE="JavaScript">
	  if (document.forms[0]) document.forms[0].neuerTitel.focus();</SCRIPT>
	  </BODY></HTML>
LABEL_ANZEIGE
}

sub gibts_checken
{
    $gibts = "nein";
    foreach $f (@filenamen) 
    {
       if ($f eq $_[0]) { $gibts = "ja"; }
    }	
    return $gibts;
}
