#!/usr/local/bin/perl

if ($ENV{'REQUEST_METHOD'} eq 'GET') 
{ 
   @pairs = split(/&/,$ENV{'QUERY_STRING'}); 
}
elsif ($ENV{'REQUEST_METHOD'} eq 'POST') 
{  
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   
   if($ENV{QUERY_STRING}) 
   {
      @getpairs = split(/&/,$ENV{'QUERY_STRING'});
      push(@pairs,@getpairs);
   }
}

foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $FORM{$name} = $value;
}

$relativer_pfad = $FORM{'pfd'};

# Berechtigung checken und @filenamen ermitteln 
require 'verz_check.cgi';
&berechtigung_checken($relativer_pfad); 

$head = $FORM{'head'};
$fl = $FORM{'fl'};
$dv = $FORM{'dv'};
$neuerTitel= $FORM{'neuerTitel'};

$neuerTitel =~ s/\\+$//;
$neuerTitel =~ s/\"/\'/;

if ($head eq "ja")      # falls Aufruf das aktuelle Verzeichnis betrifft
{

 # Titel im aktuellen Berechtigungs-File berschreiben (anhngen):
   open(FILE_SCHREIBEN,">>$relativer_pfad/.06641431691");
   flock(FILE_SCHREIBEN, 2);   
   print FILE_SCHREIBEN "\n\$_titel_{\" verz06641431691\"} = \"$neuerTitel\";  \# $aktuelle_zeit";    # Titel eintragen
   flock(FILE_SCHREIBEN, 8);
   close(FILE_SCHREIBEN);

# Falls nicht Top-Verzeichnis:
   if ($oberste_ebene ne 1)
   {
    # Name des gegenwrtigen Verzeichnisses ermitteln:
	@vrzn = split(/\//,$relativer_pfad);
	$fl = $vrzn[@vrzn-1];   

    # Titel im drberliegenden Berechtigungs-File berschreiben (anhngen):
      open(FILE_SCHREIBEN,">>$relativer_pfad/../.06641431691");
      flock(FILE_SCHREIBEN, 2);   
      print FILE_SCHREIBEN "\n\$_titel_{\"$fl\"} = \"$neuerTitel\";  \# $aktuelle_zeit";    # Titel eintragen
      flock(FILE_SCHREIBEN, 8);
      close(FILE_SCHREIBEN);
   }
   $fl ="Das aktuelle Verzeichnis"
} 
else   # falls Aufruf eine Datei oder ein Verzeichnis betrifft
{
   open(FILE_SCHREIBEN,">>$relativer_pfad/.06641431691");
   flock(FILE_SCHREIBEN, 2);   
   print FILE_SCHREIBEN "\n\$_titel_{\"$fl\"} = \"$neuerTitel\";  \# $aktuelle_zeit";     # Titel eintragen
   flock(FILE_SCHREIBEN, 8);
   close(FILE_SCHREIBEN);   	    
  
   if ($dv eq "v")  # falls von Verzeichnis kommt
   { 
   open(FILE_SCHREIBEN2,">>$relativer_pfad/$fl/.06641431691");
   flock(FILE_SCHREIBEN2, 2);   
   print FILE_SCHREIBEN2 "\n\$_titel_{\" verz06641431691\"} = \"$neuerTitel\";  \# $aktuelle_zeit";  # Titel eintragen
   flock(FILE_SCHREIBEN2, 8);
   close(FILE_SCHREIBEN2);   	  
   }
   $fl = "Das Objekt ".$fl;
}
 

print "Content-type: text/html\n\n";
print <<"LABEL_SEITE";

<HTML><HEAD><TITLE>Objekt wurde unbenannt!</TITLE></HEAD>
<BODY LINK="#0000CC" VLINK="#000099" ALINK="#009999"><A NAME="top"><FONT FACE="Arial,Helvetica">
<BR><BR>
<CENTER>
<B>$fl wurde umbenannt</B>
</CENTER>
<BR><BR>
<SCRIPT LANGUAGE="JavaScript">
window.opener.location = window.opener.location;
window.close();
</SCRIPT>
</FONT>
</BODY>
</HTML>

LABEL_SEITE


sub gibts_checken
{
    $gibts = "nein";
    foreach $f (@filenamen) 
    {
       if ($f eq $_[0]) { $gibts = "ja"; }
    }	
    return $gibts;
}
