#!/usr/local/bin/perl

if ($ENV{'REQUEST_METHOD'} eq 'GET') 
{ 
   @pairs = split(/&/,$ENV{'QUERY_STRING'}); 
}
elsif ($ENV{'REQUEST_METHOD'} eq 'POST') 
{  
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   
   if($ENV{QUERY_STRING}) 
   {
      @getpairs = split(/&/,$ENV{'QUERY_STRING'});
      push(@pairs,@getpairs);
   }
}

foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $FORM{$name} = $value;
}

$relativer_pfad = $FORM{'pfd'};
$frames = $FORM{'frames'};

# Berechtigung checken und @filenamen ermitteln 
require 'verz_check.cgi';
&berechtigung_checken($relativer_pfad); 

$farbe_link = "\#0000CC";
$farbe_vlink = "\#000099";
$farbe_alink = "\#009999";
$farbe_link_leiste = "\#6666BB";

   print "Content-type: text/html\n\n";
      
   print <<"LABEL_HTML";
<HTML>
<HEAD><TITLE>Mehrere Dateien am Server speichern</TITLE></HEAD>
<SCRIPT LANGUAGE="JavaScript">
function sonderzeichen_checken()
{
 if (  (nichtokay(document.forms[0].file_upl_01.value))
    || (nichtokay(document.forms[0].file_upl_02.value))
    || (nichtokay(document.forms[0].file_upl_03.value))
    || (nichtokay(document.forms[0].file_upl_04.value)) )
 {  
    anfeinf = "'"; anfdopp = '"';
    txt = "Eine oder mehrere Dateien enthalten zumindest eines der Zeichen &, +, ?, ; , %, #, =, " + anfdopp +
 		 ' und ' + anfeinf + " oder beginnen mit 'index'. " +
		 "Bitte ndern Sie die Namen der betreffenden Dateien auf Ihrem Computer!";
   alert(txt);
   return false;   
 } 
 else return true;
}
function nichtokay(nam)
{ 
 if (  (nam == " ") || (nam == "  ") || (nam == "   ") ||
       (nam.indexOf('&') != -1) || (nam.indexOf('+') != -1) ||
       (nam.indexOf('?') != -1) || (nam.indexOf(';') != -1) ||
       (nam.indexOf('%') != -1) || (nam.indexOf("\'") != -1) ||
	   (nam.indexOf('%') != -1) || (nam.indexOf('#') != -1) ||
	   (nam.indexOf('=') != -1) || (nam.indexOf('\"') != -1) 
	   || (nam.indexOf('index') == 0)
	   || ( (nam.indexOf('.') == 0) && (nam.indexOf('index') == 1 )	)  
    // komisch: das haut nicht hin
	//   || (nam.indexOf('/') == nam.length - 1)
     )
 return true;
 else return false;
}
</SCRIPT>
<BODY BACKGROUND="bg.gif" LINK="$farbe_link" VLINK="$farbe_vlink" ALINK="$farbe_alink">
<CENTER><TABLE WIDTH="95%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
<TD WIDTH="50%" ALIGN="left"><FONT FACE="Arial,Helvetica" SIZE="-1">
  <NOBR>&nbsp;&nbsp;<B>Mehrere Dateien am Server speichern</B></NOBR>:
  </FONT>
</TD>
<TD WIDTH="50%" ALIGN="right"><FONT FACE="Arial,Helvetica" SIZE="-1">
   <NOBR><A HREF="$scriptverzeichnis/unten.cgi?pfd=$relativer_pfad&frames=$frames"
   ><FONT COLOR="$farbe_link_leiste">Eine Datei speichern</FONT></A>
   &nbsp;&nbsp;&nbsp;&nbsp;
   <A HREF="javascript:
   hilfe = window.open('$scriptverzeichnis/hilfe_upload.cgi?pfd=$relativer_pfad','Fenster_hilfe_upload','width=580,height=492,resizable=yes,status=no,menubar=yes,scrollbars=yes,location=no');
   hilfe.focus();"><FONT COLOR="$farbe_link_leiste">Hilfe</FONT></A></FONT></TD></NOBR>   
   </FONT>
</TD>
</TABLE
><FORM ENCTYPE="multipart/form-data" ACTION="fupl.cgi" METHOD="POST"
ONSUBMIT="if (sonderzeichen_checken()) return true; else return false;"
><INPUT TYPE="hidden" NAME="pfd" VALUE="$relativer_pfad"
><INPUT TYPE="hidden" NAME="frames" VALUE="$frames"
><TABLE BORDER="0" CELLPADDING="1">
<TD>
<FONT FACE="Arial,Helvetica" SIZE="-1">Datei 1:</FONT>
</TD><TD>
<INPUT TYPE="FILE" NAME="file_upl_01" SIZE="40">
</TD><TR><TD>
<FONT FACE="Arial,Helvetica" SIZE="-1">Datei 2:</FONT>
</TD><TD>
<INPUT TYPE="FILE" NAME="file_upl_02" SIZE="40">
</TD><TR><TD>
<FONT FACE="Arial,Helvetica" SIZE="-1">Datei 3:</FONT>
</TD><TD>
<INPUT TYPE="FILE" NAME="file_upl_03" SIZE="40">
</TD><TR><TD>
<FONT FACE="Arial,Helvetica" SIZE="-1">Datei 4:</FONT>
</TD><TD>
<INPUT TYPE="FILE" NAME="file_upl_04" SIZE="40">
</TD><TR><TD>&nbsp;</TD><TD ALIGN="center"
  ><TABLE WIDTH="100%" BORDER="0" CELLPADDING="1"><TD ALIGN="center">  
  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE="SUBMIT" VALUE="Speichern">
  </TD><TD ALIGN="right">
  <INPUT TYPE="reset" VALUE="Reset">
  </TD></TABLE
></TD>
</TABLE></CENTER></FORM></BODY>
</HTML>
LABEL_HTML
