#!/usr/local/bin/perl

if ($ENV{'REQUEST_METHOD'} eq 'GET') 
{ 
   @pairs = split(/&/,$ENV{'QUERY_STRING'}); 
}
elsif ($ENV{'REQUEST_METHOD'} eq 'POST') 
{  
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   
   if($ENV{QUERY_STRING}) 
   {
      @getpairs = split(/&/,$ENV{'QUERY_STRING'});
      push(@pairs,@getpairs);
   }
}

foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $FORM{$name} = $value;
}

$relativer_pfad = $FORM{'pfd'};
$frames = $FORM{'frames'};
$details = $FORM{'details'};


# Berechtigung checken und @filenamen ermitteln 
require 'verz_check.cgi';
&berechtigung_checken($relativer_pfad); 

$neu = $FORM{'vrz'};  # Name, unter dem das Verzeichnis anzulegen ist 

    $neu =~ s/^\s+//;       # Leerzeichen am Anfang entfernen
    $neu =~ s/^\.+//;       # Punkte am Anfang werden weggezwickt
    $neu =~ s/(\s+)$//;     # Leerzeichen am Ende entfernen
    $neu =~ s/^\s+//;       # nochmals Leerzeichen am Anfang entfernen
    $neu =~ s/(\s+)$//;     # Leerzeichen am Ende entfernen
    $neu =~ s/ /_/g;        # Leerzeichen in der Mitte durch _ ersetzen
    $neu =~ s/^\.+//;       # nochmals: Punkte am Anfang werden weggezwickt

 if ( !($neu =~ /^\s*$/)                     # nicht leer
	   && !($neu =~ /\//) && !($neu =~ /\\/)  # keine Slashes und Backslashes
	   && !($neu =~ /^index/i)                # beginnt nicht mit 'index'
	   && !($neu eq "~")                      # heit nicht '~'
       && !($neu eq 'null')                   # heit nicht 'null' (z.B. wenn gecancelt)
     && !($neu =~ /\&/) && !($neu =~ /\+/) 
 	 && !($neu =~ /\?/) && !($neu =~ /;/)   # ; muss schon auf der Webseite abgefangen werden
 	 && !($neu =~ /\%/) && !($neu =~ /\#/) 
 	 && !($neu =~ /\=/) && !($neu =~ /\"/)   # " muss schon auf der Webseite abgefangen werden
	 && !($neu =~ /\'/)                      # ' muss schon auf der Webseite abgefangen werden	   
 )
{
	   # Gibt's ein gleichnamiges File schon? Dann eine Tilde (~) voranstellen
	   while (gibts_checken($neu) eq "ja")
       {
	     $neu = "~$neu";
	   }

 # Anlegen:
mkdir("$relativer_pfad/$neu",0777);
chmod(0777,"$relativer_pfad/$neu");
 
 # Berechtigungs-File anlegen:
   open(FILE_SCHREIBEN,">$relativer_pfad/$neu/.06641431691");
   flock(FILE_SCHREIBEN, 2);   
   print FILE_SCHREIBEN "\$_titel_{\" verz06641431691\"} = \"$neu\";  \# $aktuelle_zeit";    # Titel eintragen
   flock(FILE_SCHREIBEN, 8);
   close(FILE_SCHREIBEN);

   chmod (0666, "$relativer_pfad/$neu/.06641431691");

 # Default-Titel in das Berechtigungs-File schreiben (anhngen):
   open(FILE_SCHREIBEN,">>$relativer_pfad/.06641431691");
   flock(FILE_SCHREIBEN, 2);   
   print FILE_SCHREIBEN "\n\$_titel_{\"$neu\"} = \"Verzeichnis $neu\";  \# $aktuelle_zeit";    # Titel eintragen
   flock(FILE_SCHREIBEN, 8);
   close(FILE_SCHREIBEN);

use CGI qw(:standard);
$query = new CGI;
print $query->redirect("$scriptverzeichnis/show.cgi?pfd=$relativer_pfad&frames=$frames&details=$details");

}
else
{
print "Content-type: text/html\n\n";
print <<"LABEL_FEHLER";

<HTML><HEAD><TITLE>Verzeichnis wurde nicht angelegt!</TITLE></HEAD>
<BODY LINK="#0000CC" VLINK="#000099" ALINK="#009999"><A NAME="top"><FONT FACE="Arial,Helvetica" SIZE="-1">
<BR><BR>
<CENTER>
<FONT SIZE="+0"><B>Das Verzeichnis wurde nicht angelegt!</B></FONT>
<BR>&nbsp;
<TABLE WIDTH="95%"><TD><FONT FACE="Arial,Helvetica" SIZE="-1">
Der Verzeichnisname darf 
<UL>
<LI>nicht leer sein, 
<LI> keine Sonderzeichen wie Schr&auml;gstriche (&nbsp;/ und &#92;&nbsp;),
Anf&uuml;hrungszeichen (&nbsp;" und '&nbsp;) und die Symbole &amp;, +, ?, ;, %, # und = 
enthalten, <LI>nicht mit 'index' beginnen und
<LI>weder 'null' hei&szlig;en noch mit dem Symbol&nbsp;~ identisch sein.
</UL>
Beginnt der Dateiname mit Punkten, so werden diese ignoriert.
Leerzeichen werden durch das Symbol&nbsp;_ ersetzt.
</FONT></TD></TABLE>

<CENTER><BR><A HREF="javascript:history.back()">Zur&uuml;ck</A></CENTER>
</FONT>
</BODY>
</HTML>

LABEL_FEHLER
exit;
}

sub gibts_checken
{
    $gibts = "nein";
    foreach $f (@filenamen) 
    {
       if ($f eq $_[0]) { $gibts = "ja"; }
    }	
    return $gibts;
}
