#!/usr/local/bin/perl
if ($ENV{'REQUEST_METHOD'} eq 'GET') 
{ 
   @pairs = split(/&/,$ENV{'QUERY_STRING'}); 
}
elsif ($ENV{'REQUEST_METHOD'} eq 'POST') 
{  
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   
   if($ENV{QUERY_STRING}) 
   {
      @getpairs = split(/&/,$ENV{'QUERY_STRING'});
      push(@pairs,@getpairs);
   }
}
foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $FORM{$name} = $value;
}

$relativer_pfad = $FORM{'pfd'};
$details = $FORM{'details'};
$frames = $FORM{'frames'};
$von = $FORM{'von'}; 

require 'wo.cgi';
if ($frames eq "0" || $frames eq "1") { $fr = "&frames=$frames"; }
$kommtvon = "?pfd=$relativer_pfad&details=$details$fr&von=$von";

# Suche das Top-Verzeichnis
$topverz = $relativer_pfad;
while (!(-e "$topverz/.top06641431691" ))
{ $topverz = abzwick($topverz);  }

$name = $FORM{'name'};
$Email = $FORM{'Email'};
$Subject = $FORM{'Subject'};
$nachricht = $FORM{'nachricht'};
$modus = $FORM{'modus'};   # mgliche Werte: "alsText", "alsHTML"

$name =~ s/\@/\\\@/g;
$Email =~ s/\@/\\\@/g;
$Subject =~ s/\@/\\\@/g;
$nachricht =~ s/\@/\\\@/g;

$name =~ s/\$/\\\$/g;
$Email =~ s/\$/\\\$/g;
$Subject =~ s/\$/\\\$/g;
$nachricht =~ s/\$/\\\$/g;

if ($name ne "") { $name = "<B>$name</B>"; }

if ($modus eq "alsText") { $nachricht = "<PRE><FONT SIZE='+0'>$nachricht"; }
if ($Subject eq "") { $Subject ="<FONT COLOR='#6666BB'>--- ohne Titel ---</FONT>"; }

if    (($name ne "") && ($Email ne "")) { $name = "<A HREF=\"mailto:$Email\">$name</A>"; }
elsif (($name eq "") && ($Email ne "")) { $name = "<A HREF=\"mailto:$Email\"><B>$Email</B></A>"; }

# Zeit feststellen:
   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime(time);
   $jahr = $year - 100 + 2000;
   @months = (1,2,3,4,5,6,7,8,9,10,11,12);
   if ($min<10) {$min = "0$min"; }   
   $Datum = "\&nbsp;<FONT COLOR='#6666BB'>$mday.\&nbsp;$months[$mon].\&nbsp;$jahr\&nbsp;$hour:$min</FONT>\&nbsp;";
   $textmarke_pur = "$mday$months[$mon]$jahr$hour$min$sec";
   $textmarke ="<A NAME=\"$textmarke_pur\"></A>";

# Template-Text einlesen:

      open(FILE_LESEN,"<template.txt");
      flock(FILE_LESEN, 2);
      @alsArray = <FILE_LESEN>;   # enthlt die einzelnen Zeilen
      flock(FILE_LESEN, 8);
      close(FILE_LESEN);

      $eintrag = "";   
      foreach $j (@alsArray) { $eintrag = $eintrag.$j; }  


# Ersetzungen im Template-Text:
# cgiLABeL_Textmarke ... Textmarke, Beispiel: <A NAME="7829472894"></A>
# cgiLABeL_Name ... Name bzw Email oder beides. Beispiel:
#   <A HREF="mailto: feap.univie.ac.at"><FONT COLOR="#6666BB">Franz&nbsp;Embacher</FONT></A>
# cgiLABeL_Subject ... Subject (oder no Subject)
# cgiLABeL_Datum ... Zeit, Beispiel: &nbsp;25.&nbsp;8.&nbsp;2004&nbsp;14:39&nbsp;
# cgi_LABeL_Nachricht  ... Nachricht (als Text oder HTML>

$eintrag =~ s/cgiLABeL_Textmarke/$textmarke/;
$eintrag =~ s/cgiLABeL_Name/$name/;
$eintrag =~ s/cgiLABeL_Subject/$Subject/;
$eintrag =~ s/cgiLABeL_Datum/$Datum/;
$eintrag =~ s/cgi_LABeL_Nachricht/$nachricht/;


# inhalt_notizen.cgi einlesen:

      open(FILE_LESEN,"<$topverz/.notizen/inhalt_notizen.cgi");
      flock(FILE_LESEN, 2);
      @alsArray2 = <FILE_LESEN>;   # enthlt die einzelnen Zeilen
      flock(FILE_LESEN, 8);
      close(FILE_LESEN);

      $indextext = "";   
      foreach $j (@alsArray2) { $indextext = $indextext.$j; } 

# Ersetzung in inhalt_notizen.cgi
# <!-- cgiEINTRaG -->  ... kompletter Beitrag

$eintrag = "$eintrag\n\n<!-- cgiEINTRaG -->";
$indextext =~ s/<!-- cgiEINTRaG -->/$eintrag/;

# ... und in inhalt_notizen.cgi schreiben
   open(FILE_SCHREIBEN1,">$topverz/.notizen/inhalt_notizen.cgi");
   flock(FILE_SCHREIBEN1, 2);
   print FILE_SCHREIBEN1 $indextext;
   flock(FILE_SCHREIBEN1, 8);
   close(FILE_SCHREIBEN1);

urlbestimmen();

print "Content-type: text/html\n\n";
print <<"LABEL_SEITE";
<HTML><HEAD><TITLE>Notiz wurde eingetragen</TITLE></HEAD>
<BODY LINK="#0000CC" VLINK="000099" ALINK="#009999">
<SCRIPT LANGUAGE="JavaScript">
 window.opener.location.reload(true); 
 setTimeout("window.opener.location = '$scriptverzeichnis/$topverz/.notizen/notizen.cgi$kommtvon\#$textmarke_pur'",1000);
</SCRIPT>
<FONT FACE="Arial,Helvetica" SIZE="-1">
<BR><BR>
&nbsp;&nbsp;&nbsp;<B>Die Notiz wurde eingetragen!</B>
<BR><BR><BR><BR><CENTER><A HREF="javascript:history.back()">Zur&uuml;ck</A>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<A HREF="javascript:window.close()">Schlieen</A>
</CENTER>
</FONT></BODY></HTML>
LABEL_SEITE

sub urlbestimmen
{
$scriptverzeichnis = "http://$ENV{'SERVER_NAME'}$ENV{'REQUEST_URI'}";

# Allflliges ?... im URL wegzwicken
@bestandteile_scr = split(/\?/,$scriptverzeichnis);
$scriptverzeichnis = $bestandteile_scr[0];  # alles vor dem Fragezeichen

# Allflliges #... im URL wegzwicken
@bestandteile_dash = split(/\#/,$scriptverzeichnis);
$scriptverzeichnis = $bestandteile_dash[0];  # alles vor dem #

@bestandteile_rest = split(/\//,$scriptverzeichnis);
$scriptverzeichnis = "";
    for ($i=0; $i<@bestandteile_rest-1; $i++)  # Letzten Teil = Namen DIESES Files am Ende streichen
	{
	  $scriptverzeichnis = "$scriptverzeichnis/$bestandteile_rest[$i]";
	}
	
$scriptverzeichnis =~ s/\/http/http/;
while ($scriptverzeichnis =~ /\/\//)
{ $scriptverzeichnis =~ s/\/\//\//; }    # Mehrfach-Slashes entfernen
{ $scriptverzeichnis =~ s/http:\//http:\/\//; }

}

sub abzwick
{
  @testverz = split(/\//,$_[0]);
  $testv = "";
  for ($i=0;$i<@testverz-1;$i=$i+1)
  { $testv = "$testv$testverz[$i]/"; } 
  $testv =~ s/\/$//;
  return $testv;
}
