#!/usr/local/bin/perl

if ($ENV{'REQUEST_METHOD'} eq 'GET') 
{ 
   @pairs = split(/&/,$ENV{'QUERY_STRING'}); 
}
elsif ($ENV{'REQUEST_METHOD'} eq 'POST') 
{  
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   
   if($ENV{QUERY_STRING}) 
   {
      @getpairs = split(/&/,$ENV{'QUERY_STRING'});
      push(@pairs,@getpairs);
   }
}

foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $FORM{$name} = $value;
}

$relativer_pfad = $FORM{'pfd'};
$frames = $FORM{'frames'};
$details = $FORM{'details'};

# Berechtigung checken und @filenamen ermitteln 
require 'verz_check.cgi';
&berechtigung_checken($relativer_pfad); 

foreach $j (@filenamen) 
{
   if ((-f "$relativer_pfad/$j") && ($j ne ".06641431691") 
   && ($j ne ".top06641431691"))
      # Die Berechtigungs-Dateien werden nicht gelscht
   {  
      unlink("$relativer_pfad/$j");
   }
}

use CGI qw(:standard);
$query = new CGI;
print $query->redirect("$scriptverzeichnis/show.cgi?pfd=$relativer_pfad&frames=$frames&details=$details");
