#!/usr/local/bin/perl

if ($ENV{'REQUEST_METHOD'} eq 'GET') 
{ 
   @pairs = split(/&/,$ENV{'QUERY_STRING'}); 
}
elsif ($ENV{'REQUEST_METHOD'} eq 'POST') 
{  
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   
   if($ENV{QUERY_STRING}) 
   {
      @getpairs = split(/&/,$ENV{'QUERY_STRING'});
      push(@pairs,@getpairs);
   }
}

foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $FORM{$name} = $value;
}

$relativer_pfad = $FORM{'pfd'};
$frames = $FORM{'frames'};
$details = $FORM{'details'};

# Berechtigung checken und @filenamen ermitteln 
require 'verz_check.cgi';
&berechtigung_checken($relativer_pfad); 

require "$relativer_pfad/.06641431691"; 

$neu = $FORM{'neu'};

foreach $j (@filenamen) 
{
   if ($j eq $FORM{'fl'}) 
   {  
      $jj = $j;
      $betreffendedatei = "$relativer_pfad/$j"; 
   }
}

if (-e $betreffendedatei) # falls die Datei im betreffenden Verzeichnis liegt
{ 
   if ($FORM{'cl'} eq "ja")          # Aufruf kommt von Lschen-Link
   { 
      if (-f $betreffendedatei) # falls Datei
      {
	     unlink($betreffendedatei);    # betreffende Datei lschen
	  }
	  elsif (-d $betreffendedatei) # falls Verzeichnis
      {
	 # Schauen, ob das Verzeichnis tatschlich leer ist (bis auf eine Berechtigungs-Datei)
         opendir(VERZ,$betreffendedatei);
         @filenamen_v = readdir(VERZ);
         closedir(VERZ);	
		 $leer ="*";
		 foreach $fl_v (@filenamen_v)
		 { # Wenn es noch andere Unix-Eintragungen gibt:
		   if (!(($fl_v eq ".") || ($fl_v eq "..") || ($fl_v eq ".06641431691") || ($fl_v eq ".htaccess"))) 
		   { $leer = ""; }
		 }		 
         # Wenn leer, alles lschen:
		 if ($leer eq "*")
	     {
	       unlink("$betreffendedatei/.06641431691");    # Berechtigungs-Datei lschen
		   if (-f "$betreffendedatei/.htaccess")
		   {
		     unlink("$betreffendedatei/.htaccess");  
		   }		   
	       rmdir($betreffendedatei);    # betreffendes Verzeichnis lschen (mu leer sein)
		 }
	  }	  
   }
   else                 # Aufruf kommt vom Rename-Link
   {
             $neu =~ s/^\s+//;       # Leerzeichen am Anfang entfernen
             $neu =~ s/^\.+//;       # Punkte am Anfang werden weggezwickt
	         $neu =~ s/^\s+//;       # nochmals Leerzeichen am Anfang entfernen
             $neu =~ s/(\s+)$//;     # Leerzeichen am Ende entfernen
             $neu =~ s/ /_/g;        # Leerzeichen in der Mitte durch _ ersetzen
             $neu =~ s/^\.+//;       # nochmals: Punkte am Anfang werden weggezwickt       
	   
	  if (-d $betreffendedatei)  # falls Verzeichnis
	  { $compare1 = "null";    # soll nicht 'null' heien
	    $compare2 = "~";        # soll nicht ~ heien
	    $neu =~ s/(\s+)$//;     # Leerzeichen am Ende entfernen
		$verzz = 1;
	  }   
	  elsif (-f $betreffendedatei)  # falls Datei
	  { $compare1 = ""; 
	    $compare2 = ""; 
		$verzz = 0;
	  }

      if ( ($neu ne $compare1) && !($neu =~ /^\s*$/)  # nicht leer oder undefiniert
	       && !($neu =~ /\//) && !($neu =~ /\\/)  # keine Slashes und Backslashes
	       && !($neu =~ /^index/i)                # beginnt nicht mit 'index'
		   && !($neu eq $compare2)                      # heit nicht '~'
          && !($neu =~ /\&/) && !($neu =~ /\+/) 
 	      && !($neu =~ /\?/) && !($neu =~ /;/)   # ; muss schon auf der Webseite abgefangen werden
 	      && !($neu =~ /\%/) && !($neu =~ /\#/) 
 	      && !($neu =~ /\=/) && !($neu =~ /\"/)   # " muss schon auf der Webseite abgefangen werden
	      && !($neu =~ /\'/)                      # ' muss schon auf der Webseite abgefangen werden
	     )
	      {
			 if ($neu ne $jj)
			 {
			    # Gibt's ein gleichnamiges File schon? Dann eine Tilde (~) voranstellen
			    while (gibts_checken($neu) eq "ja")
                {
			       $neu = "~$neu";
			    }
		     }
			 rename($betreffendedatei,"$relativer_pfad/$neu");   # umbenennen
			 
 # Default-Titel in das Berechtigungs-File schreiben (anhngen):
   open(FILE_SCHREIBEN,">>$relativer_pfad/.06641431691");
   flock(FILE_SCHREIBEN, 2);   
   if ($verzz eq 1) # falls Verzeichnis
   {   if (exists $_titel_{$jj})
      { print FILE_SCHREIBEN "\n\$_titel_{\"$neu\"} = \$_titel_{\"$jj\"};  \# $aktuelle_zeit"; }   # alten Titel bernehmen
	  else
      { print FILE_SCHREIBEN "\n\$_titel_{\"$neu\"} = \"Verzeichnis $neu\";  \# $aktuelle_zeit"; }   # Default-Titel eintragen	  
	  
   # und dann noch im neuen Verzeichnis ausbessern:
   
   require "$relativer_pfad/$neu/.06641431691"; 

 # ggf Default-Titel im jeweiligen Berechtigungs-File ndern:
   open(FILE_SCHREIBEN2,">>$relativer_pfad/$neu/.06641431691");
   flock(FILE_SCHREIBEN2, 2);   
   if ($_titel_{" verz06641431691"} eq $jj)   # falls der Titel nur der Verzeichnisname war -> entsprechend umbenennen
   { 
     print FILE_SCHREIBEN2 "\n\$_titel_{\" verz06641431691\"} = \"$neu\";  \# $aktuelle_zeit";  # Default-Titel eintragen
   }
   flock(FILE_SCHREIBEN2, 8);
   close(FILE_SCHREIBEN2);   
	  
   }
   elsif ($verzz eq 0)  # falls Datei
   {   if (exists $_titel_{$jj})
      { print FILE_SCHREIBEN "\n\$_titel_{\"$neu\"} = \$_titel_{\"$jj\"};  \# $aktuelle_zeit"; }   # alten Titel bernehmen
	  else
      { print FILE_SCHREIBEN "\n\$_titel_{\"$neu\"} = \"Datei $neu\";  \# $aktuelle_zeit"; }   # Default-Titel eintragen	  
   }
   flock(FILE_SCHREIBEN, 8);
   close(FILE_SCHREIBEN);
   
	      }
		  else
		  {
print "Content-type: text/html\n\n";
print <<"LABEL_FEHLER";

<HTML><HEAD><TITLE>Datei/Verzeichnis wurde nicht umbenannt!</TITLE></HEAD>
<BODY LINK="#0000CC" VLINK="#000099" ALINK="#009999"><A NAME="top"><FONT FACE="Arial,Helvetica" SIZE="-1">
<CENTER><BR>
<FONT SIZE="+0"><B>Die Datei/Das Verzeichnis wurde nicht umbenannt!</B></FONT>
<BR>&nbsp;
<TABLE WIDTH="95%"><TD><FONT FACE="Arial,Helvetica" SIZE="-1">
Ein <B>Dateiname</B> darf 
<UL>
<LI>nicht leer sein, 
<LI> keine Sonderzeichen wie Schr&auml;gstriche (&nbsp;/ und &#92;&nbsp;),
Anf&uuml;hrungszeichen (&nbsp;" und '&nbsp;) und die Symbole &amp;, +, ?, ;, %, # und = 
enthalten.
</UL>
Ein <B>Verzeichnisname</B> darf - neben denselben Einschr&auml;nkungen -
<UL>
<LI>nicht mit 'index' beginnen und
<LI>weder 'null' hei&szlig;en noch mit dem Symbol&nbsp;~ identisch sein.
</UL>
Beginnt ein Name mit Punkten, so werden diese ignoriert.
Leerzeichen werden durch das Symbol&nbsp;_ ersetzt.
</FONT></TD></TABLE>
<BR>
<CENTER><A HREF="javascript:history.back()">Zur&uuml;ck</A></CENTER>
</FONT>
</BODY>
</HTML>

LABEL_FEHLER
exit;
		  }
   } 

use CGI qw(:standard);
$query = new CGI;
print $query->redirect("$scriptverzeichnis/show.cgi?pfd=$relativer_pfad&frames=$frames&details=$details");

}
else
{
print "Content-type: text/html\n\n";
print <<"LABEL_FEHLER";

<HTML><HEAD><TITLE>Fehler!</TITLE></HEAD>
<BODY LINK="#0000CC" VLINK="#000099" ALINK="#009999"><A NAME="top"><FONT FACE="Arial,Helvetica">
<BR><BR><BR><BR>
<CENTER>
<H1>Fehler!</H1>
<BR><BR>
<TABLE WIDTH="95%"><TD><FONT FACE="Arial,Helvetica">
Das angegebene Objekt scheint nicht zu existieren!
</FONT></TD></TABLE>
<BR><BR>
<CENTER><A HREF="javascript:history.back()">Zur&uuml;ck</A></CENTER>
</FONT>
</BODY>
</HTML>

LABEL_FEHLER
}



sub gibts_checken
{
    $gibts = "nein";
    foreach $f (@filenamen) 
    {
       if ($f eq $_[0]) { $gibts = "ja"; }
    }	
    return $gibts;
}
