#!/usr/local/bin/perl

  # Wunsch:
  # Falls $frames=0 und in einem Fenster (Variable: uploaden, Fenstername: Fenster_upload)
  # die Upload-Eingabemaske geffnet ist, dann soll dieses
  # - a.) beim Verlassen via Link auf Dokument, Back und Forward geschlossen werden,
  # - b.) bei Link auf Verzeichnis oder nchsthhere Ebene aktualisiert werden
  # Dafr sorgt teilweise im Code unten die Variable $aktu bzw die Konstruktion mit der
  # Variablen schliessen.
  # Verbleibendes Restproblem: Nach Aktionen, die die Seite reloaden (z.B. Umbenennungen)
  # wird das Fenster nicht mehr erkannt. 
  # Eine diesbezgliche KORREKTUR betrfe die Funktion fensteroffen()!
  # Immerhin produziert diese Version keine JavaScript-Fehler.
  # Daher Verhaltensregel -> bei Verwendung des Upload-Fensters immer berprfen,
  # ob gerade das richtige Verzeichnis geladen ist.

if ($ENV{'REQUEST_METHOD'} eq 'GET') 
{ 
   @pairs = split(/&/,$ENV{'QUERY_STRING'}); 
}
elsif ($ENV{'REQUEST_METHOD'} eq 'POST') 
{  
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   
   if($ENV{QUERY_STRING}) 
   {
      @getpairs = split(/&/,$ENV{'QUERY_STRING'});
      push(@pairs,@getpairs);
   }
}

foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $FORM{$name} = $value;
}

$relativer_pfad = $FORM{'pfd'};
$frames = $FORM{'frames'};
$details = $FORM{'details'};

# Berechtigung checken und @filenamen ermitteln 
require 'verz_check.cgi';
&berechtigung_checken($relativer_pfad); 

# Default: details=0 und frames=0

if ($details ne "1") { $details = 0; }
if ($frames ne "1") { $frames = 0; }

require "$relativer_pfad/.06641431691";

$farbe_link = "\#0000CC";
$farbe_vlink = "\#000099";
$farbe_alink = "\#009999";
$farbe_link_leiste = "\#6666BB";
$farbe_aktionen = "\#885555";
$farbe_leiste ="\#EEEEFF";

$mitzaehlen = 0;

# Die URLs der cgi-Scripts, die URL&pfd=$repativer_pfad empfangen, werden absolut adressiert, 
# da ansonsten z.B. Script-Seiten mit $relativer_pfad="../../files" zwar im
# Browser geladen, Script-Seiten mit $relativer_pfad="../../../notizen/notizen" aber
# NICHT geladen werden (sondern der URL grndlich miverstanden wird).
#
# Dazu dient $scriptverzeichnis = der URL des Verzeichnisses DIESER Datei (bzw.
# der anderen) Script-Dateien, ohne Slash am Ende.
# Er wird von verz_check.cgi geliefert.

# URL des aktuellen bearbeiteten Verzeichnisses = Zielverzeichnisses (ohne Slash am Ende)
$url = &entf("$scriptverzeichnis/$relativer_pfad"); 


if ($oberste_ebene ne 1)
{ 
   $oberer_pfad = "";
    @tl = split(/\//,$relativer_pfad);
    for ($i=0; $i<@tl-2; $i++)
    {
	  $oberer_pfad = $oberer_pfad.$tl[$i]."/";
    }
	  $oberer_pfad = $oberer_pfad.$tl[@tl-2];	  
   
   $aktu = " ONCLICK = \'if (fensteroffen())\n Upl_mitziehen(\"$scriptverzeichnis/unten.cgi?pfd=$oberer_pfad&frames=0\");\'\n";
   
   if ($frames eq "0")
   { $hinauf = "<FONT FACE='Arial,Helvetica' SIZE='-1'\n".
               "><A HREF=\'$scriptverzeichnis/show.cgi?pfd=$oberer_pfad&frames=0&details=$details\' TARGET='_top'$aktu".
	       "><IMG SRC='../verzup.gif' BORDER='0' WIDTH='27' HEIGHT='13' ALT='Zum n&auml;chsthheren Verzeichnis'></A></FONT>"; 
   }
   else
   { $hinauf = "<FONT FACE='Arial,Helvetica' SIZE='-1'\n".
               "><A HREF=\'$scriptverzeichnis/shupl.cgi?pfd=$oberer_pfad&frames=1&details=$details\' TARGET='_top'\n".
	       "><IMG SRC='../verzup.gif' BORDER='0' WIDTH='27' HEIGHT='13' ALT='Zum n&auml;chsthheren Verzeichnis'></A></FONT>"; 
   }           
}
else { 
   #    $hinauf = "<FONT FACE='Arial,Helvetica' SIZE='-1'\n".
   #              ">&nbsp;<A HREF='http://future-media.univie.ac.at/software/Ibyco' TARGET='_blank'\n".
   #              "STYLE='text-decoration:none'><FONT COLOR='$farbe_link_leiste'>Ibyco&nbsp;Homepage</FONT></A></FONT>"; 
   $hinauf="&nbsp;";
     }



   if ($frames eq "0")
   {  $uploaden = "&nbsp;&nbsp;&nbsp;&nbsp;\n".
                  "<A HREF=\"javascript: openUpl('$scriptverzeichnis/unten.cgi?pfd=$relativer_pfad&frames=0');\"\n".
                  "STYLE='text-decoration:none'><FONT COLOR='$farbe_link_leiste'>Upload</FONT></A>";
   }				     
   else
   {  $uploaden = "";  }

# Suche das Top-Verzeichnis
$topverz = $relativer_pfad;
while (!(-e "$topverz/.top06641431691" ))
{ $topverz = abzwick($topverz);  }

print "Content-type: text/html\n\n";
print <<"LABEL_SEITE";

<HTML><HEAD><TITLE>Ibyco: $_titel_{' verz06641431691'}</TITLE></HEAD>
<SCRIPT LANGUAGE="JavaScript">
window.parent.name="Show_Fenster";
var uploaden;
var schliessen=1;  // jeder Link, der eine andere Seite ldt und das Upload-Fenster NICHT schliessen soll, muss schliessen=0 setzen!

function fensteroffen()       // Wird abgefragt bei Mitziehen und von fschliessen(). 
                              // Sollte true ergeben, falls Upload-Fenster offen,
{                             // ERKENNT das Fenster aber NICHT IMMER!
  if ((uploaden != null) && (!(uploaden.closed)))
  { schliessen=0;  
    return true; }
  else
  return false;
}
function fschliessen()   // wird bei jedem Verlassen der Seite aufgerufen: falls schliessen=1 und Fenster offen, soll es schliessen
{
  if (fensteroffen() && (schliessen==1))
  uploaden.close();
}
function openUpl(txtvar)
{
  schliessen=1;
  uploaden = window.open(txtvar,'Fenster_upload','width=620,height=110,resizable=yes,status=no,menubar=yes,scrollbars=yes,location=no');
  uploaden.focus();
}
function Upl_mitziehen(txtvar)  // ohne focus
{
  uploaden = window.open(txtvar,'Fenster_upload','width=620,height=110,resizable=yes,status=no,menubar=yes,scrollbars=yes,location=no');
}
function neuesV()
{
   prom = prompt('Neues Verzeichnis anlegen:','NeuesVerzeichnis');
   if (prom)
   { prom = AE(prom);   
   prom = PU(prom);
   prom = AE(prom);
   prom = ERSETZE(prom," ","_");   
   prom = PU(prom); }     
   txt = "Bitte keine Schrgstriche und Sonderzeichen im Verzeichnisnamen! " +
         "Siehe 'Hilfe' fr weitere Details. Neues Verzeichnis anlegen:";
   while ((prom) && ((prom == "") || (prom == " ") || (prom == "  ") || (prom == "   ") ||
       (prom.indexOf('/') != -1) ||
	   // (prom == "~") ||  // das funktioniert komischerweise nicht
	    (prom.indexOf("\'") != -1)
       || (prom.indexOf('\"') != -1) || (prom == "null") || (prom.indexOf('index') == 0) 
	 || (prom.indexOf('&') != -1) || (prom.indexOf('+') != -1) ||
	          (prom.indexOf('?') != -1) || (prom.indexOf(';') != -1) ||
	          (prom.indexOf('%') != -1) || (prom.indexOf("\'") != -1) ||
	   	   (prom.indexOf('%') != -1) || (prom.indexOf('#') != -1) ||
	   	   (prom.indexOf('=') != -1)  
	   || ( (prom.indexOf('.') == 0) && (prom.indexOf('index') == 1 )	)    ))
   { prom = prompt(txt,prom);
     prom = AE(prom);      
     prom = PU(prom);   
     prom = AE(prom);
     prom = ERSETZE(prom," ","_");
     prom = PU(prom); 	 
   }
   if (prom) 
   {  
    schliessen=0;
    document.location = '$scriptverzeichnis/verzanlegen.cgi?pfd=$relativer_pfad&vrz='+prom+'&frames=$frames&details=$details';
   }	  
}
function Ren(verz,dat)
{
   txt = verz + " " + dat + " umbenennen zu:"; 
   prom = dat;
   prom = prompt(txt,dat);   
   if (prom)
   { prom = AE(prom);      
   prom = PU(prom);   
   prom = AE(prom);
   prom = ERSETZE(prom," ","_");   
   prom = PU(prom); }
   while ((prom) && ((prom == "") || (prom == " ") || (prom == "  ") || (prom == "   ") ||
		  (prom.indexOf('/') != -1) 
	     ||  (prom.indexOf("\'") != -1) || (prom.indexOf('\"') != -1) || (prom.indexOf('index') == 0) 
         || (prom.indexOf('&') != -1) || (prom.indexOf('+') != -1) ||
	          (prom.indexOf('?') != -1) || (prom.indexOf(';') != -1) ||
	          (prom.indexOf('%') != -1) || (prom.indexOf("\'") != -1) ||
	   	   (prom.indexOf('%') != -1) || (prom.indexOf('#') != -1) ||
	   	   (prom.indexOf('=') != -1)  
	   || ( (prom.indexOf('.') == 0) && (prom.indexOf('index') == 1) )    ))	   	   
   {  
      prom = prompt("Bitte keine Schrgstriche und Sonderzeichen im "+verz+"namen! Siehe 'Hilfe' fr weitere Details. "+txt,prom);
      prom = AE(prom);   	  
      prom = PU(prom);	  
      prom = AE(prom);
      prom = ERSETZE(prom," ","_");
      prom = PU(prom);	  
   }      
   if (prom) 
   {  
      schliessen=0;
      document.location = '$scriptverzeichnis/rendel.cgi?pfd=$relativer_pfad&fl='+dat+'&neu='+prom+'&frames=$frames&details=$details';
   }
}
function ERSETZE(s, a, b)
{   var n, laengea, laengeb;

      laengea = a.length;
      laengeb = b.length; 

      while(s.indexOf(a) != -1)
      {
       n = s.indexOf(a);       
       if (0<=n && n <= s.length-laengea)        
       {  if (n==0) 
           s = b+s.substring(laengea,s.length);  
          else if (n == s.length-laengea)
           s=s.substring(0,n)+b; 
          else
           s=s.substring(0,n)+b+s.substring(n+laengea,s.length);
       }
      }
     return s;             
}
function PU(s)    // vorne die Punkte abschneiden
{ 
      while(s.indexOf(".") == 0)
      { s = s.substring(1,s.length); }
      return s;             
}
function AE(s)    // vorne und hinten die Leerzeichen abschneiden
{ 
      while(s.indexOf(" ") == 0)
      { s = s.substring(1,s.length); }
	  while(s.lastIndexOf(" ") == s.length-1 )
	  { s = s.substring(0,s.length-1); }
      return s;             
}
function Clear(vrzd,was,rndl)
{
   if (confirm(vrzd+' '+was+' wirklich lschen?'))
   { schliessen=0; document.location = rndl; }
}
function Reload()
{
   schliessen=0; document.location=document.location;
}
function AlleLoeschen(vrz)
{
	 if (confirm('Wirklich alle Dateien lschen?'))
	 {  schliessen=0; document.location = vrz; }
}
</SCRIPT> <!-- Hgr: FCFCF7 ??? -->
<BODY LINK="$farbe_link" VLINK="$farbe_vlink" ALINK="$farbe_alink" ONUNLOAD="fschliessen()"><A NAME="top">
<FONT FACE="Arial,Helvetica" SIZE="-1">

<CENTER>

<TABLE WIDTH="95%" BORDER="0" CELLPADDING="3" CELLSPACING="0" BGCOLOR="#9999CC"><!-- Alternativen: "#8888BB"  "#666699" -->
<TD ALIGN="left" WIDTH="25%"><FONT FACE="Arial,Helvetica" SIZE="-1">&nbsp;<NOBR>
   <A HREF="http://future-media.univie.ac.at/software/Ibyco" TARGET="_blank" STYLE='text-decoration:none'><FONT COLOR="$farbe_leiste">Ibyco&nbsp;Homepage</FONT></A>
   </NOBR></FONT></TD>
<TD ALIGN="right" WIDTH="75%"><FONT FACE="Arial,Helvetica" SIZE="-1">
   <NOBR><A HREF="$scriptverzeichnis/$topverz/.notizen/notizen.cgi?pfd=$relativer_pfad&details=$details&frames=$frames&von=$scriptverzeichnis/shupl.cgi" TARGET="_top"><FONT COLOR="$farbe_leiste" STYLE='text-decoration:none'>Notizen</FONT></A>   
   &nbsp;&nbsp;&nbsp;&nbsp;
   <A HREF="javascript:
   shbkms = window.open('$scriptverzeichnis/$topverz/.notizen/eingetragene_bookms.cgi?pfd=$relativer_pfad&details=$details&frames=$frames&von=$scriptverzeichnis/shupl.cgi','Fenster_showBookmarks','width=520,height=450,resizable=yes,status=no,menubar=yes,scrollbars=yes,location=no');
   shbkms.focus();" STYLE="text-decoration:none"><FONT COLOR="$farbe_leiste">Bookmarks</FONT></A>      
   &nbsp;&nbsp;&nbsp;&nbsp;   
   <A HREF="javascript: Reload()"
   STYLE="text-decoration:none"><FONT COLOR="$farbe_leiste">Reload</FONT></A>   
   &nbsp;&nbsp;&nbsp;&nbsp;
   <A HREF="javascript:
   hilfe = window.open('hilfe_show.html','Fenster_hilfe_show','width=580,height=462,resizable=yes,status=no,menubar=yes,scrollbars=yes,location=no');
   hilfe.focus();" STYLE="text-decoration:none"><FONT COLOR="$farbe_leiste">Hilfe</FONT></A></NOBR>   
   </FONT>
</TD>
</TABLE>

<TABLE WIDTH="95%" BORDER="0" CELLPADDING="3" CELLSPACING="0" BGCOLOR="$farbe_leiste">
<TD ALIGN="left" WIDTH="25%">$hinauf</TD>
<TD ALIGN="right" WIDTH="75%"><FONT FACE="Arial,Helvetica" SIZE="-1">
   <NOBR><A HREF="javascript:
   editneu = window.open('$scriptverzeichnis/edit.cgi?neuesdok=1&pfd=$relativer_pfad','Fenster_edit_neu','width=750,height=490,resizable=yes,status=no,menubar=yes,scrollbars=yes,location=no');
   editneu.focus();" STYLE="text-decoration:none"><FONT COLOR="$farbe_link_leiste">Neues Text-Dokument</FONT></A>   
   &nbsp;&nbsp;&nbsp;&nbsp;
   <A HREF="javascript: neuesV();" STYLE="text-decoration:none"><FONT COLOR="$farbe_link_leiste">Neues Verzeichnis</FONT></A>
   $uploaden
   &nbsp;&nbsp;&nbsp;&nbsp;
   <A HREF="javascript:
   titaend = window.open('$scriptverzeichnis/titelaendern.cgi?pfd=$relativer_pfad&head=ja','Fenster_Titelaendern_head','width=600,height=115,resizable=yes,status=no,menubar=no,scrollbars=yes,location=no');
   titaend.focus();" STYLE="text-decoration:none"><FONT COLOR="$farbe_link_leiste">C</FONT></A></NOBR>   
   </FONT>
</TD></TABLE>
<BR>
<FONT SIZE="+0"><B>$_titel_{' verz06641431691'}</B></FONT> <BR><BR> $url/</CENTER><BR>

<CENTER><TABLE WIDTH="95%" BORDER="0" CELLPADDING="1" CELLSPACING="2">
LABEL_SEITE

# WIDTHs der TDs:
if ($details ne "0")
{ $t1 = "20%";
  $t2 = "38%";
  $t3 = "2%";
  $t4 = "10%";
  $t5 = "5%";
  $t6 = "10%";
  $t7 = "5%";
  $t8 = "5%";
  $t9 = "5%"; }
else
{ $t1 = "30%";
  $t2 = "53%";
  $t3 = "2%";
  $t7 = "5%";
  $t8 = "5%";
  $t9 = "5%";
}

# DIE FILES UND VERZEICHNISSE

# zunchst ordnen: zuerst die Verzeichnisse, dann die Dateien, jeweils alphabetisch

foreach $j (@filenamen)
{
  if ((-d "$relativer_pfad/$j") && (!($j =~ m/^\./))) 
                     # Systemdateien (die mit einem Punkt beginnen) nicht anzeigen!!!
  { push(@allenamen,$j); }                           # Verzeichnisse
  elsif ((-f "$relativer_pfad/$j") && (!($j =~ m/^\./))) 
  { push(@dateinamen,$j); }                          # Dateien
}
@allenamen = sort (@allenamen); 
@dateinamen = sort (@dateinamen); 
foreach $j (@dateinamen) { push(@allenamen,$j); }


foreach $j (@allenamen)    # Systemdateien (die mit einem Punkt beginnen) wurden oben ausgeschlossen
{
   # Name:
   # ----
   # falls Verzeichnis:
   if (-d "$relativer_pfad/$j") { $verzbild = "<IMG SRC='../verz.gif' BORDER='0' WIDTH='15' HEIGHT='13'>&nbsp;";
                                  $datverz = "Verzeichnis"; 
								  
					if ($frames eq "0")
					{ $link = "$scriptverzeichnis/show.cgi?pfd=$relativer_pfad/$j&frames=0&details=$details"; }
					else
					{ $link = "$scriptverzeichnis/shupl.cgi?pfd=$relativer_pfad/$j&frames=1&details=$details"; }
								  
	                                opendir(VERZ,"$relativer_pfad/$j");
		                        @filenamen_v = readdir(VERZ);
                                        closedir(VERZ);	
		                        # Ein Sternchen fr ein leeres Verzeichnis
		                        $leer ="<FONT COLOR='$farbe_link_leiste'>*</FONT>";
		                        foreach $fl_v (@filenamen_v)
		                        {                          # Wenn es nicht nur diese Unix-Eintragungen gibt,
		                          if (!(($fl_v eq ".") || ($fl_v eq "..") 
		                             || ($fl_v eq ".06641431691") || ($fl_v eq ".top06641431691") 
				    	     || ($fl_v eq ".htaccess"))) 
		                          { $leer = ""; }          # wird das Verzeichnis als nicht-leer deklariert
		                        }
																		
                                        $aktu = " ONCLICK = \'if (fensteroffen())\n Upl_mitziehen(\"$scriptverzeichnis/unten.cgi?pfd=$relativer_pfad/$j&frames=0\");\'\n";
				}
   # falls Datei:
   else { $verzbild = ""; 
          $datverz = "Datei"; 
	  $link = "$url/$j"; 
          $leer = "";            # gar keine Anzeige fr Dateien
          $aktu = "";
	}

   print "<TR><TD WIDTH='$t1' ALIGN='left' BGCOLOR='$farbe_leiste'>&nbsp;&nbsp;<FONT FACE='Arial,Helvetica' SIZE='-1'\n";
   print "><A HREF='$link' TARGET='_top'$aktu";
   print "STYLE='text-decoration:none'>$verzbild</A><A HREF='$link' TARGET='_top'$aktu>$j</A>$leer</FONT></TD>\n"; 

   # Titel:
   # -----
   $titel = $_titel_{"$j"};   # wird von .06641431691 bernommen
   print "<TD WIDTH='$t2' ALIGN='left' BGCOLOR='$farbe_leiste'><TABLE BORDER='0' CELLPADDING='0' CELLSPACING='0'\n";
   print "><TD>&nbsp;&nbsp;</TD><TD><FONT FACE='Arial,Helvetica' SIZE='-1'\n";
   print ">$titel</FONT></TD></TABLE></TD>\n";               

   # Change Titel:
   # ------------
   if (-d "$relativer_pfad/$j") { $dv = "v"; }
   else { $dv = "d"; }
   print "<TD WIDTH='$t3' ALIGN='center' BGCOLOR='$farbe_leiste'><FONT FACE='Arial,Helvetica' SIZE='-1'\n";
       $eintr = "<A HREF=\"javascript:\n".
   	        "titae = window.open('$scriptverzeichnis/titelaendern.cgi?pfd=$relativer_pfad&fl=$j&dv=$dv','Fenster_Titelaendern_$mitzaehlen','width=600,height=115,resizable=yes,status=no,menubar=no,scrollbars=yes,location=no');\n".
       "titae.focus();\"><FONT COLOR='$farbe_aktionen'>C</FONT></A>";
   print ">&nbsp;$eintr&nbsp;</FONT></TD>\n";  

if ($details ne "0")
{
   # Dateigre in Byte:
   # ------------------
   $eintr = (stat("$relativer_pfad/$j"))[7]; # Filegre
   print "<TD  WIDTH='$t4' ALIGN='right' BGCOLOR='$farbe_leiste'><FONT FACE='Arial,Helvetica' SIZE='-1'\n";
   print ">&nbsp;$eintr&nbsp;Byte&nbsp;</FONT></TD>\n";  

   # Dateityp:
   # --------
   if (-T "$relativer_pfad/$j")   # falls Text-Datei
   {    if ($j =~ m/\.html$/i || $j =~ m/\.htm$/i || $j =~ m/\.shtml$/i) { $eintr = "HTML" ; }
        elsif ($j =~ m/\.cgi$/i || $j =~ m/\.pl$/i || $j =~ m/\.js$/i) { $eintr = "Script" ; }
		elsif ($j =~ m/\.java$/i) { $eintr = "Java" ; }
		elsif ($j =~ m/\.ps$/i)  { $eintr = "PS" ; }
        else { $eintr = "Text"; } 
   }
   else    # falls Binr-Datei
   { 
        if ($j =~ m/\.gif$/i || $j =~ m/\.jpg$/i || $j =~ m/\.jpeg$/i
		|| $j =~ m/\.tif$/i || $j =~ m/\.tiff$/i || $j =~ m/\.bmp$/i) { $eintr = "Bild" ; }
        elsif ($j =~ m/\.doc$/i || $j =~ m/\.rtf$/i)  { $eintr = "Word" ; }
        elsif ($j =~ m/\.xls$/i)  { $eintr = "Excel" ; }
        elsif ($j =~ m/\.ppt$/i)  { $eintr = "PowerPoint" ; }
		elsif ($j =~ m/\.pdf$/i)  { $eintr = "PDF" ; }
        elsif ($j =~ m/\.mpeg$/i) { $eintr = "Video" ; }
        elsif ($j =~ m/\.zip$/i)  { $eintr = "ZIP" ; }
        elsif ($j =~ m/\.exe$/i)  { $eintr = "EXE" ; }
        elsif ($j =~ m/\.class$/i || $j =~ m/\.jar$/i)  { $eintr = "Java" ; }
		elsif (-d "$relativer_pfad/$j") { $eintr = "Verz" ; }
        else { $eintr = "bin"; }
   }
   print "<TD WIDTH='$t5' ALIGN='left' BGCOLOR='$farbe_leiste'><FONT FACE='Arial,Helvetica' SIZE='-1'\n";
   print ">&nbsp;$eintr&nbsp;</FONT></TD>\n";       


   # mtime (last modified time) des Files:
   # ------------------------------------
   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime((stat("$relativer_pfad/$j"))[9]);
   $jahr = $year - 100;
   if ($jahr<10) { $jahr = "0$jahr"; }
   @months = (1,2,3,4,5,6,7,8,9,10,11,12);
   if ($months[$mon]<10) {$months[$mon] = "0$months[$mon]"; }
   if ($mday<10) {$mday = "0$mday"; }
   if ($hour<10) {$hour = "0$hour"; }
   if ($min<10) {$min = "0$min"; }   
   $eintr = "$mday.$months[$mon].$jahr&nbsp;$hour:$min";

   print "<TD WIDTH='$t6' ALIGN='right' BGCOLOR='$farbe_leiste'><FONT FACE='Arial,Helvetica' SIZE='-1'\n";
   print ">&nbsp;$eintr&nbsp;</FONT></TD>\n";  
}

   # Edit:
   # ----
   if (-T "$relativer_pfad/$j")    # falls Text-Datei
   { 
      $mitzaehlen = $mitzaehlen + 1;
      $eintr = "<A HREF=\"javascript:\n".
	   "edit = window.open('$scriptverzeichnis/edit.cgi?pfd=$relativer_pfad&fl=$j','Fenster_edit_$mitzaehlen','width=750,height=490,resizable=yes,status=no,menubar=yes,scrollbars=yes,location=no');\n".
       "edit.focus();\"><FONT COLOR='$farbe_aktionen'>Edit</FONT></A>";
   }
   else { $eintr = ""; }
   print "<TD WIDTH='$t7' ALIGN='center' BGCOLOR='$farbe_leiste'><FONT FACE='Arial,Helvetica' SIZE='-1'\n";
   print ">&nbsp;$eintr&nbsp;</FONT></TD>";            
   
   # Ren (Rename):
   # ------------
   print "<TD WIDTH='$t8' ALIGN='center' BGCOLOR='$farbe_leiste'><FONT FACE='Arial,Helvetica' SIZE='-1'\n";
   print ">&nbsp;<A HREF='javascript: Ren(\"$datverz\",\"$j\")'><FONT COLOR='$farbe_aktionen'>Ren</FONT></A>&nbsp;</FONT></TD>\n";               
   
   # Cl (Clear):
   # ----------
   print "<TD WIDTH='$t9' ALIGN='center' BGCOLOR='$farbe_leiste'><FONT FACE='Arial,Helvetica' SIZE='-1'\n";
   print ">&nbsp;<A HREF=\"javascript: Clear(\'$datverz\',\'$j\',\'$scriptverzeichnis/rendel.cgi?pfd=$relativer_pfad&fl=$j&cl=ja&frames=$frames&details=$details\')\" \n";
   print "><FONT COLOR='$farbe_aktionen'>Cl</FONT></A>&nbsp;</FONT></TD>\n";      
   print "</TR>\n";

}

print "</TABLE>\n<BR>"; 


if (@allenamen eq 0) # d.h. keine Dateien + Verzeichnisse (auer den Berechtigungs-Dateien)
{     print "<CENTER><B>Derzeit befinden sich keine Objekte in diesem Verzeichnis.</B></CENTER><BR><BR>";  }

print "<TABLE WIDTH='95%' BORDER='0' CELLPADDING='3' CELLSPACING='0' BGCOLOR='$farbe_leiste'>";

if (($frames eq "0") && ($details eq "0"))
{ $wechseln = "<A HREF='$scriptverzeichnis/shupl.cgi?pfd=$relativer_pfad&frames=1&details=0'\n".
              "STYLE='text-decoration:none'><FONT COLOR='$farbe_link_leiste'>Uploadframe anzeigen</FONT></A>"; 
  $det = "<A HREF='$scriptverzeichnis/show.cgi?pfd=$relativer_pfad&frames=0&details=1' ONCLICK='schliessen=0;'\n".
         "STYLE='text-decoration:none'><FONT COLOR='$farbe_link_leiste'>Details anzeigen</FONT></A>"; }

elsif (($frames ne "0") && ($details eq "0"))
{ $wechseln = "<A HREF='$scriptverzeichnis/show.cgi?pfd=$relativer_pfad&frames=0&details=0' TARGET='_top'\n".
              "STYLE='text-decoration:none'><FONT COLOR='$farbe_link_leiste'>Uploadframe verstecken</FONT></A>"; 
  $det = "<A HREF='$scriptverzeichnis/show.cgi?pfd=$relativer_pfad&frames=1&details=1' ONCLICK='schliessen=0;'\n".
         "STYLE='text-decoration:none'><FONT COLOR='$farbe_link_leiste'>Details anzeigen</FONT></A>"; }

elsif (($frames eq "0") && ($details ne "0"))
{ $wechseln = "<A HREF='$scriptverzeichnis/shupl.cgi?pfd=$relativer_pfad&frames=1&details=1'\n".
              "STYLE='text-decoration:none'><FONT COLOR='$farbe_link_leiste'>Uploadframe anzeigen</FONT></A>"; 
  $det = "<A HREF='$scriptverzeichnis/show.cgi?pfd=$relativer_pfad&frames=0&details=0' ONCLICK='schliessen=0;'\n".
         "STYLE='text-decoration:none'><FONT COLOR='$farbe_link_leiste'>Details verstecken</FONT></A>"; }

elsif (($frames ne "0") && ($details ne "0"))
{ $wechseln = "<A HREF='$scriptverzeichnis/show.cgi?pfd=$relativer_pfad&frames=0&details=1' TARGET='_top'\n".
              "STYLE='text-decoration:none'><FONT COLOR='$farbe_link_leiste'>Uploadframe verstecken</FONT></A>"; 
  $det = "<A HREF='$scriptverzeichnis/show.cgi?pfd=$relativer_pfad&frames=1&details=0' ONCLICK='schliessen=0;'\n".
         "STYLE='text-decoration:none'><FONT COLOR='$farbe_link_leiste'>Details verstecken</FONT></A>"; }


if (@dateinamen ne 0)
{  
     print "<TD ALIGN='right'>\n";
     print "<FONT FACE='Arial,Helvetica' SIZE='-1'><NOBR>\n"; 
      $versch = "<A HREF=\"javascript:\n".
	   "versch = window.open('$scriptverzeichnis/verschieben.cgi?pfd=$relativer_pfad&fl=$j','Fenster_versch','width=750,height=490,resizable=yes,status=no,menubar=yes,scrollbars=yes,location=no');\n".
       "versch.focus();\" STYLE='text-decoration:none'><FONT COLOR='$farbe_link_leiste'>Objekte verschieben</FONT></A>\n";	 
	 print $versch;
     print "&nbsp;&nbsp;&nbsp;&nbsp;\n";  
      $allez = "<A HREF=\"javascript:\n".
	   "allez = window.open('$scriptverzeichnis/../inhalt.cgi?pfd=$relativer_pfad&details=$details&frames=$frames&from=show','Fenster_allez','width=240,height=400,resizable=yes,status=no,menubar=no,scrollbars=yes,location=no');\n".
       "allez.focus();\" STYLE='text-decoration:none'><FONT COLOR='$farbe_link_leiste'>Alle zeigen</FONT></A>\n";	 
	 print $allez;	 
     print "&nbsp;&nbsp;&nbsp;&nbsp;\n";  	 	 
     print "<A HREF=\"javascript: AlleLoeschen('$scriptverzeichnis/allesloeschen.cgi?pfd=$relativer_pfad&frames=$frames&details=$details')\"\n";
     print "STYLE='text-decoration:none'><FONT COLOR='$farbe_link_leiste'>Alle Dateien l&ouml;schen</FONT></A>\n";
     print "&nbsp;&nbsp;&nbsp;&nbsp;\n$wechseln\n";
     print "&nbsp;&nbsp;&nbsp;&nbsp;\n$det\n&nbsp;&nbsp;\n";   
}
else # if (@allenamen eq 0)   # d.h. keine Dateien + Verzeichnisse (auer den Berechtigungs-Dateien)
{
   print "<TD ALIGN='right'>\n";
   print "<FONT FACE='Arial,Helvetica' SIZE='-1'><NOBR>\n";   
      $versch = "<A HREF=\"javascript:\n".
	   "versch = window.open('$scriptverzeichnis/verschieben.cgi?pfd=$relativer_pfad&fl=$j','Fenster_versch','width=750,height=490,resizable=yes,status=no,menubar=yes,scrollbars=yes,location=no');\n".
       "versch.focus();\" STYLE='text-decoration:none'><FONT COLOR='$farbe_link_leiste'>Objekte verschieben</FONT></A>\n";	 
	 print $versch;	 
     print "&nbsp;&nbsp;&nbsp;&nbsp;\n";   
      $allez = "<A HREF=\"javascript:\n".
	   "allez = window.open('$scriptverzeichnis/../inhalt.cgi?pfd=$relativer_pfad&details=$details&frames=$frames&from=show','Fenster_allez','width=240,height=400,resizable=yes,status=no,menubar=no,scrollbars=yes,location=no');\n".
       "allez.focus();\" STYLE='text-decoration:none'><FONT COLOR='$farbe_link_leiste'>Alle zeigen</FONT></A>\n";	 
	 print $allez;	 
     print "&nbsp;&nbsp;&nbsp;&nbsp;\n"; 	 
   print "$wechseln\n";
   print "&nbsp;&nbsp;&nbsp;&nbsp;\n$det\n&nbsp;&nbsp;\n";   
}
print "</NOBR></FONT></TD></TABLE>";

print "</CENTER>\n</FONT>\n</BODY>\n</HTML>";


# ----------------------------------------------------------------------------------------


sub entf
{
    # Strukturen vom Typ /A/.. aus URLs entfernen
    @teile = split(/\//,$_[0]);
    for ($i=0; $i<@teile; $i++)
    {
         if ($teile[$i] eq "..")
   	  {
   	     $teile[$i] = "";
   	     $kindex = 1;
	     while (($teile[$i-$kindex] eq "") && ($i-$kindex>1))  # letzteres verhindert Endlosschleife
	     { 
	       $kindex = $kindex + 1;   # Index des letzten nichtleeren Teils
	     }
	     $teile[$i-$kindex] = "";  # den letzten Teil, der nicht leer ist, entfernen,
	                               # um auch Strukturen wie A/../../B zu erfassen
	  }
    }
    $url_aux="";
    foreach $k (@teile)  { $url_aux = "$url_aux/$k"; }
    $url_aux =~ s/\/http/http/;
    while ($url_aux =~ /\/\//)
    { $url_aux =~ s/\/\//\//; }    # Mehrfach-Slashes entfernen
    $url_aux =~ s/http:\//http:\/\//;
    return $url_aux;
}

sub abzwick
{
  @testverz = split(/\//,$_[0]);
  $testv = "";
  for ($i=0;$i<@testverz-1;$i=$i+1)
  { $testv = "$testv$testverz[$i]/"; } 
  $testv =~ s/\/$//;
  return $testv;
}