#!/usr/local/bin/perl
# Variante von show.cgi

if ($ENV{'REQUEST_METHOD'} eq 'GET') 
{ 
   @pairs = split(/&/,$ENV{'QUERY_STRING'}); 
}
elsif ($ENV{'REQUEST_METHOD'} eq 'POST') 
{  
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   
   if($ENV{QUERY_STRING}) 
   {
      @getpairs = split(/&/,$ENV{'QUERY_STRING'});
      push(@pairs,@getpairs);
   }
}

foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $FORM{$name} = $value;
}

# Bei der bergabe ans Script wird die Variable $relativer_pfad aus 
# Konsistenzgrnden mit den anderen Scripts relativ zum Verzeichnis ftools gerechnet.

$relativer_pfad = $FORM{'pfd'};
$pos = $FORM{'pos'};

# Berechtigung checken und @filenamen ermitteln 
require 'verz_check.cgi';
&berechtigung_checken($relativer_pfad); 

require "$relativer_pfad/.06641431691";

$farbe_link = "\#0000CC";
$farbe_vlink = "\#000099";
$farbe_alink = "\#009999";
$farbe_link_leiste = "\#6666BB";
$farbe_leiste ="\#EEEEFF";

$mitzaehlen = 0;

# Die URLs der cgi-Scripts, die URL&pfd=$repativer_pfad empfangen, werden absolut adressiert, 
# da ansonsten z.B. Script-Seiten mit $relativer_pfad="../../files" zwar im
# Browser geladen, Script-Seiten mit $relativer_pfad="../../../notizen/notizen" aber
# NICHT geladen werden (sondern der URL grndlich miverstanden wird).
#
# Dazu dient $scriptverzeichnis = der URL des Verzeichnisses DIESER Datei (bzw.
# der anderen) Script-Dateien, ohne Slash am Ende.
# Er wird von verz_check.cgi geliefert.

# URL des aktuellen bearbeiteten Verzeichnisses = Zielverzeichnisses (ohne Slash am Ende)
$url = &entf("$scriptverzeichnis/$relativer_pfad"); 


if ($oberste_ebene ne 1)
{ 
   $oberer_pfad = "";
    @tl = split(/\//,$relativer_pfad);
    for ($i=0; $i<@tl-2; $i++)
    {
	  $oberer_pfad = $oberer_pfad.$tl[$i]."/";
    }
	  $oberer_pfad = $oberer_pfad.$tl[@tl-2];	  
   
      $hinauf = "<FONT FACE='Arial,Helvetica' SIZE='-1'\n".
               "><A HREF=\'$scriptverzeichnis/v_dir.cgi?pfd=$oberer_pfad&pos=$pos\'".
	       "><IMG SRC='../verzup.gif' BORDER='0' WIDTH='27' HEIGHT='13' ALT='Zum n&auml;chsthheren Verzeichnis'></A></FONT>";
}
else { 
       $hinauf = "&nbsp;";
     }

if ($pos eq "links")
{
  $eintragg = "Zu bewegende Objekte markieren";
}
elsif ($pos eq "rechts")
{
  $eintragg = "Zielverzeichnis einstellen";
}
else
{
   print "Content-type: text/html\n\n";
   print "<HTML><FONT FACE='Arial,Helvetica'><CENTER><BR><BR><BR><BR><H1>Falsche Anwendung!</H1></CENTER></FONT></HTML>";
   exit;
}


print "Content-type: text/html\n\n";
print <<"LABEL_SEITE";

<HTML><HEAD><TITLE>Ibyco: $_titel_{' verz06641431691'}</TITLE></HEAD>
<SCRIPT LANGUAGE="JavaScript">
var verzeichnis = "$relativer_pfad";
</SCRIPT>
<BODY LINK="$farbe_link" VLINK="$farbe_vlink" ALINK="$farbe_alink"><A NAME="top">
<FONT FACE="Arial,Helvetica" SIZE="-1">

<CENTER>
<TABLE WIDTH="95%" BORDER="0" CELLPADDING="3" CELLSPACING="0" BGCOLOR="$farbe_leiste">
<TD ALIGN="left" WIDTH="10%">$hinauf</TD>
<TD ALIGN="center" WIDTH="80%"><FONT FACE="Arial,Helvetica" SIZE="-1">
   <NOBR>
   <FONT COLOR="$farbe_link_leiste">$eintragg</FONT>
   </NOBR>   
   </FONT>
</TD><TD ALIGN="left" WIDTH="10%">&nbsp;</TD></TABLE>
<BR>
<FONT SIZE="+0"><B>$_titel_{' verz06641431691'}</B></FONT> <BR><BR> $url/</CENTER><BR>

<CENTER><FORM><TABLE WIDTH="95%" BORDER="0" CELLPADDING="1" CELLSPACING="2">
LABEL_SEITE

# WIDTHs der TDs:
if ($pos eq "links")
{
  $t1 = "30%";
  $t2 = "60%";
  $t3 = "10%";
}
else
{
  $t1 = "30%";
  $t2 = "70%";
}

# DIE FILES UND VERZEICHNISSE

# zunchst ordnen: zuerst die Verzeichnisse, dann die Dateien, jeweils alphabetisch

foreach $j (@filenamen)
{
  if ((-d "$relativer_pfad/$j") && (!($j =~ m/^\./))) 
                     # Systemdateien (die mit einem Punkt beginnen) nicht anzeigen!!!
  { push(@allenamen,$j); }                           # Verzeichnisse
  elsif ((-f "$relativer_pfad/$j") && (!($j =~ m/^\./))) 
  { push(@dateinamen,$j); }                          # Dateien
}
@allenamen = sort (@allenamen); 
@dateinamen = sort (@dateinamen); 
foreach $j (@dateinamen) { push(@allenamen,$j); }

foreach $j (@allenamen)    # Systemdateien (die mit einem Punkt beginnen) wurden oben ausgeschlossen
{
   # Name:
   # ----
   # falls Verzeichnis:
   if (-d "$relativer_pfad/$j") { $verzbild = "<IMG SRC='../verz.gif' BORDER='0' WIDTH='15' HEIGHT='13'>&nbsp;";
                                  $link = "$scriptverzeichnis/v_dir.cgi?pfd=$relativer_pfad/$j&pos=$pos"; 
	                                opendir(VERZ,"$relativer_pfad/$j");
		                        @filenamen_v = readdir(VERZ);
                                        closedir(VERZ);	
		                        # Ein Sternchen fr ein leeres Verzeichnis
		                        $leer ="*";
		                        foreach $fl_v (@filenamen_v)
		                        {                          # Wenn es nicht nur diese Unix-Eintragungen gibt,
		                          if (!(($fl_v eq ".") || ($fl_v eq "..") 
		                             || ($fl_v eq ".06641431691") || ($fl_v eq ".top06641431691") 
				    	             || ($fl_v eq ".htaccess"))) 
		                             { $leer = ""; }          # wird das Verzeichnis als nicht-leer deklariert
		                         }								  
                                }
   # falls Datei:
   else { $verzbild = ""; 
	      $link = "$url/$j"; 
          $leer = "";            # gar keine Anzeige fr Dateien	    }
        }
   print "<TR><TD WIDTH='$t1' ALIGN='left' BGCOLOR='$farbe_leiste'>&nbsp;&nbsp;<FONT FACE='Arial,Helvetica' SIZE='-1'\n";
   print "><A HREF='$link' STYLE='text-decoration:none'>$verzbild</A\n".
         "><A HREF='$link'>$j</A>$leer</FONT></TD>\n"; 

   # Titel:
   # -----
   $titel = $_titel_{"$j"};   # wird von .06641431691 bernommen
   print "<TD WIDTH='$t2' ALIGN='left' BGCOLOR='$farbe_leiste'><TABLE BORDER='0' CELLPADDING='0' CELLSPACING='0'\n";
   print "><TD>&nbsp;&nbsp;</TD><TD><FONT FACE='Arial,Helvetica' SIZE='-1'\n";
   print ">$titel</FONT></TD></TABLE></TD>\n";                
   
  # Checkbox:
  # --------
  if ($pos eq "links")
  {
    $mitzaehlen = $mitzaehlen + 1;
    print "<TD WIDTH='$t3' ALIGN='center' BGCOLOR='$farbe_leiste'";
    print ">&nbsp;<INPUT TYPE='checkbox' NAME='box$mitzaehlen'";
	print "><INPUT TYPE='hidden' NAME='datei$mitzaehlen' VALUE='$relativer_pfad/$j'>&nbsp;</TD>\n";
  } 
   
   print "</TR>\n";
   
}
print "</TABLE></FORM>\n<BR>"; 

if (@allenamen eq 0) # d.h. keine Dateien + Verzeichnisse (auer den Berechtigungs-Dateien)
{     
   print "<CENTER><B>Derzeit befinden sich keine Objekte in diesem Verzeichnis.</B></CENTER><BR><BR>";  
}
#   print "<TABLE WIDTH='95%' BORDER='0' CELLPADDING='3' CELLSPACING='0' BGCOLOR='$farbe_leiste'>";
#   print "<TD ALIGN='right'>&nbsp;</TD></TABLE>";
   print "</CENTER>\n</FONT>\n</BODY>\n</HTML>";

# ----------------------------------------------------------------------------------------

sub entf
{
    # Strukturen vom Typ /A/.. aus URLs entfernen
    @teile = split(/\//,$_[0]);
    for ($i=0; $i<@teile; $i++)
    {
         if ($teile[$i] eq "..")
   	  {
   	     $teile[$i] = "";
   	     $kindex = 1;
	     while (($teile[$i-$kindex] eq "") && ($i-$kindex>1))  # letzteres verhindert Endlosschleife
	     { 
	       $kindex = $kindex + 1;   # Index des letzten nichtleeren Teils
	     }
	     $teile[$i-$kindex] = "";  # den letzten Teil, der nicht leer ist, entfernen,
	                               # um auch Strukturen wie A/../../B zu erfassen
	  }
    }
    $url_aux="";
    foreach $k (@teile)  { $url_aux = "$url_aux/$k"; }
    $url_aux =~ s/\/http/http/;
    while ($url_aux =~ /\/\//)
    { $url_aux =~ s/\/\//\//; }    # Mehrfach-Slashes entfernen
    $url_aux =~ s/http:\//http:\/\//;
    return $url_aux;
}
