#!/usr/local/bin/perl

if ($ENV{'REQUEST_METHOD'} eq 'GET') 
{ 
   @pairs = split(/&/,$ENV{'QUERY_STRING'}); 
}
elsif ($ENV{'REQUEST_METHOD'} eq 'POST') 
{  
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   
   if($ENV{QUERY_STRING}) 
   {
      @getpairs = split(/&/,$ENV{'QUERY_STRING'});
      push(@pairs,@getpairs);
   }
}

foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $FORM{$name} = $value;
}

$typ = $FORM{'typ'};
$relativer_pfad = $FORM{'pfd'};
$alt = $FORM{'alt'};
$neu = $FORM{'neu'};

if ($typ eq "1")
{

print "Content-type: text/html\n\n";
print <<"LABEL_WARN1";

<HTML><HEAD><TITLE>Dokument wurde w&auml;hrend der Bearbeitung gel&ouml;scht</TITLE></HEAD>
<BODY BGCOLOR="#FFFF99" LINK="#0000CC" VLINK="#000099" ALINK="#009999"><FONT FACE="Arial,Helvetica" SIZE="-1">
<FONT SIZE="+0"><B>Achtung</B></FONT>:<BR><BR>
Die Datei <B>$alt</B> 
wurde w&auml;hrend der Bearbeitung von einem anderen Proze&szlig; gel&ouml;scht! Die 
neue Version Dokument wurde unter dem Namen 
<CENTER><BR><A HREF="$relativer_pfad/$neu" TARGET="_blank">$neu</A></CENTER><BR>
gespeichert. <DIV ALIGN="right"><A HREF="javascript: window.close();">Schlie&szlig;en</A>&nbsp;&nbsp;&nbsp;&nbsp;</DIV>
</FONT></BODY></HTML>
LABEL_WARN1
}
elsif ($typ eq "2")
{

$differenz_txt = $FORM{'differenz_txt'};
$differenz_txt =~ s/\*/ /g;

print "Content-type: text/html\n\n";
print <<"LABEL_WARN2";

<HTML><HEAD><TITLE>Dokument wurde nicht &uuml;berschrieben</TITLE></HEAD>
<BODY BGCOLOR="#FFFF99" LINK="#0000CC" VLINK="#000099" ALINK="#009999"><FONT FACE="Arial,Helvetica" SIZE="-1">
<FONT SIZE="+0"><B>Achtung</B></FONT>:<BR><BR>
Die Datei <A HREF="$relativer_pfad/$alt" TARGET="_blank">$alt</A> 
wurde w&auml;hrend der Bearbeitung (vor $differenz_txt) von einem anderen Proze&szlig; verndert! Das 
Dokument wurde <I>nicht</I> &uuml;berschrieben, sondern unter dem neuen Namen 
<CENTER><BR><A HREF="$relativer_pfad/$neu" TARGET="_blank">$neu</A></CENTER><BR>
gespeichert. <DIV ALIGN="right"><A HREF="javascript: window.close();">Schlie&szlig;en</A>&nbsp;&nbsp;&nbsp;&nbsp;</DIV>
</FONT></BODY></HTML>
LABEL_WARN2
}