#!/usr/local/bin/perl

if ($ENV{'REQUEST_METHOD'} eq 'GET') 
{ 
   @pairs = split(/&/,$ENV{'QUERY_STRING'}); 
}
elsif ($ENV{'REQUEST_METHOD'} eq 'POST') 
{  
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   
   if($ENV{QUERY_STRING}) 
   {
      @getpairs = split(/&/,$ENV{'QUERY_STRING'});
      push(@pairs,@getpairs);
   }
}

foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $FORM{$name} = $value;
}

$relativer_pfad = $FORM{'pfd'};
$relativer_pfad =~ s/^(..\/)//;      # ../ am Beginn entfernen, da dieses Script 
                                     # eine Ebene hher als die Scripts in ftools ist.
$details = $FORM{'details'};
$frames = $FORM{'frames'};
$from = $FORM{'from'};

# Berechtigung checken und @filenamen ermitteln 
require 'verz_check_read.cgi';
&berechtigung_checken($relativer_pfad); 

# Suche das Top-Verzeichnis:
while (!(-e "$relativer_pfad/.top06641431691" ))
{ $relativer_pfad = abzwick($relativer_pfad);  }

print "Content-type: text/html\n\n";
print "<HTML><HEAD><TITLE>Liste aller Objekte</TITLE>\n";
print "<STYLE>\n   A {text-decoration:none}\n</STYLE>\n</HEAD>\n";
print "<SCRIPT LANGUAGE='JavaScript'>\n";
print "function welcherBrowser()  // brow hat danach die Werte 'NN' oder 'sonstiger'\n";
print "{  if (navigator.appName.indexOf('Netscape') != -1) brow='NN';\n";
print "   else brow='sonstiger'; } // IE vor 4 oder sonstiger Browser\n";
print "welcherBrowser();  // wird auf jeden Fall ausgefhrt\n";  
print "if (brow == 'NN')\n";
print "  var OPP = window.opener.parent; \n";  
print "function load (txt)  { \n";
if ($from eq "read")  # kommt von read
 { 
   print "  window.opener.location = '$scriptverzeichnis/read.cgi?pfd='+txt+'&details=$details'; \n"; 
   print " }\n";
 }
 else  # kommt von show
 { 
   $scriptv = $scriptverzeichnis;
   if ($scriptv =~ /\/\.\.$/)
   {  $scriptv =~ s/\/\.\.$//;  } # am Ende /.. wegnehmen
   else   # trifft fr (manche?) IE zu
   { $scriptv = "$scriptv/ftools"; }  

   print "if (brow == 'NN')\n";
   print "  OPP.location = '$scriptv/shupl.cgi?pfd='+txt+'&details=$details&frames=$frames';\n";    
   print "else\n";
   print "  window.open('$scriptv/shupl.cgi?pfd='+txt+'&details=$details&frames=$frames','Show_Fenster');\n";
   print " }\n";   
}

print "function loaddat(txt) { \n";
print "if (brow == 'NN')\n";
print "  OPP.location = txt; \n"; 
print "else\n";
print "  window.open(txt,'Show_Fenster'); \n"; 
print " }\n";   

print "function Reload() { document.location = document.location; }\n";

print "</SCRIPT>\n";
print "<BODY LINK='#000000' VLINK='#000000' ALINK='#009999'><FONT FACE='Arial,Helvetica' SIZE='-1'>\n";
print "<CENTER><BR> <B>Liste aller Objekte</B></CENTER> <BR>\n";

$hier = 0;
$inh = 0;

$bild = "<IMG SRC='verz.gif' WIDTH='15' HEIGHT='13' BORDER='0'>&nbsp;";
print "<NOBR>\n\&nbsp;$leerz</NOBR><A HREF='javascript:load(\"../$relativer_pfad\")'>$bild"."Top</A>";

verzeichnisse_absuchen($relativer_pfad);

if ($inh eq 0)
{ print "<CENTER>Keine Objekte vorhanden!</CENTER>"; }
print "<BR><BR>";
print "<DIV ALIGN='center'><A HREF='javascript:Reload()'><FONT COLOR='#6666BB'>Reload</FONT></A></DIV>\n";
print "<BR></BODY></HTML>";


sub verzeichnisse_absuchen
{ 
  $nixdrin = 1;
  opendir(VERZ."$_[0]verzeichnisse",$_[0]);
  
  if (-e "$_[0]/.06641431691")
  {
    foreach $j (sort readdir(VERZ."$_[0]verzeichnisse")) 
    {
       if (($j !~ /^\./) && (-d "$_[0]/$j"))
       { $nixdrin = 0;
	     $leerz = leerzeichen($hier+1);
         $bild = "<IMG SRC='verz.gif' WIDTH='15' HEIGHT='13' BORDER='0'>&nbsp;";
         $inh = 1;
         print "<BR><NOBR>\n\&nbsp;$leerz</NOBR><A HREF='javascript:load(\"../$_[0]/$j\")'>$bild$j</A>";
         $hier = $hier + 1;
         verzeichnisse_absuchen("$_[0]/$j");
         $hier = $hier - 1;
       }
    }		
  }
  else 
  { 
     $leerz = leerzeichen($hier - 1);
     print "<NOBR><B>\n ... ung&uuml;ltiges Verzeichnis</B></NOBR>"; 
  }
  closedir(VERZ."$_[0]verzeichnisse");  
  
  
  opendir(VERZ."$_[0]dateien",$_[0]);
  
  if (-e "$_[0]/.06641431691")
  {
    foreach $j (sort readdir(VERZ."$_[0]dateien")) 
    {
       if (($j !~ /^\./) && (-f "$_[0]/$j"))
       { $nixdrin = 0;
	     $leerz = leerzeichen($hier+1);
         $bild = "";
         $inh = 1;
         print "<BR><NOBR>\n\&nbsp;$leerz<A HREF='javascript:loaddat(\"$_[0]/$j\")'>$bild$j</A></NOBR>";
       }
    }		
  }
  closedir(VERZ."$_[0]dateien");   
  
  if ($nixdrin eq 1) { print "*"; }
}


sub leerzeichen
{
  $leeraux = "";
  $mitz = 0;
  for ($k=0; $k < $_[0]; $k=$k+1)
  { # $leeraux = $leeraux.'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'; 
    $mitz = $mitz + 1;
    if ($mitz eq $_[0])
    { $leeraux = $leeraux."<IMG SRC='orth.gif' WIDTH='15' HEIGHT='13'>\&nbsp;"; }
    else
    { $leeraux = $leeraux."<IMG SRC='vert.gif' WIDTH='15' HEIGHT='13'>\&nbsp;"; }  
  
  }
  return $leeraux;
}

sub abzwick
{
  @testverz = split(/\//,$_[0]);
  $testv = "";
  for ($i=0;$i<@testverz-1;$i=$i+1)
  { $testv = "$testv$testverz[$i]/"; } 
  $testv =~ s/\/$//;
  return $testv;
}