#!/usr/local/bin/perl
$schr_modus = 1;
# Variante von show.cgi

if ($ENV{'REQUEST_METHOD'} eq 'GET') 
{ 
   @pairs = split(/&/,$ENV{'QUERY_STRING'}); 
}
elsif ($ENV{'REQUEST_METHOD'} eq 'POST') 
{  
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   
   if($ENV{QUERY_STRING}) 
   {
      @getpairs = split(/&/,$ENV{'QUERY_STRING'});
      push(@pairs,@getpairs);
   }
}

foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $FORM{$name} = $value;
}

# Bei der bergabe ans Script wird die Variable $relativer_pfad aus 
# Konsistenzgrnden mit den anderen Scripts relativ zum Verzeichnis ftools gerechnet.

$relativer_pfad = $FORM{'pfd'};
$relativer_pfad =~ s/^(..\/)//;    # ../ am Beginn entfernen, da dieses Script eine Ebene hher als show.cgi ist.
$details = $FORM{'details'};

# Berechtigung checken und @filenamen ermitteln 
require 'verz_check_read.cgi';
&berechtigung_checken($relativer_pfad); 

# Default: details=0

if ($details ne "1") { $details = 0; }

require "$relativer_pfad/.06641431691";

$farbe_link = "\#0000CC";
$farbe_vlink = "\#000099";
$farbe_alink = "\#009999";
$farbe_link_leiste = "\#6666BB";
$farbe_aktionen = "\#885555";
$farbe_leiste ="\#EEEEFF";

# Die URLs der cgi-Scripts, die URL&pfd=$repativer_pfad empfangen, werden absolut adressiert, 
# da ansonsten z.B. Script-Seiten mit $relativer_pfad="../../files" zwar im
# Browser geladen, Script-Seiten mit $relativer_pfad="../../../notizen/notizen" aber
# NICHT geladen werden (sondern der URL grndlich miverstanden wird).
#
# Dazu dient $scriptverzeichnis = der URL des Verzeichnisses DIESER Datei (bzw.
# der anderen) Script-Dateien, ohne Slash am Ende.
# Er wird von verz_check.cgi geliefert.

# URL des aktuellen bearbeiteten Verzeichnisses = Zielverzeichnisses (ohne Slash am Ende)
$url = &entf("$scriptverzeichnis/$relativer_pfad"); 


if ($oberste_ebene ne 1)
{ 
   $oberer_pfad = "";
    @tl = split(/\//,$relativer_pfad);
    for ($i=0; $i<@tl-2; $i++)
    {
	  $oberer_pfad = $oberer_pfad.$tl[$i]."/";
    }
	  $oberer_pfad = $oberer_pfad.$tl[@tl-2];	  
   
      $hinauf = "<FONT FACE='Arial,Helvetica' SIZE='-1'\n".
               "><A HREF=\'$scriptverzeichnis/read.cgi?pfd=../$oberer_pfad&details=$details\'".
	       "><IMG SRC='verzup.gif' BORDER='0' WIDTH='27' HEIGHT='13' ALT='Zum n&auml;chsthheren Verzeichnis'></A></FONT>";
}
else { 
       $hinauf = "<FONT FACE='Arial,Helvetica' SIZE='-1'\n".
                 ">&nbsp;<A HREF='http://future-media.univie.ac.at/software/Ibyco'\n".
                 "TARGET='_blank' STYLE='text-decoration:none'><FONT COLOR='$farbe_link_leiste'>Ibyco&nbsp;Homepage</FONT></A></FONT>"; 
     }

if ($schr_modus eq 1)
  {  
    $schr = "<A HREF='$scriptverzeichnis/ftools/show.cgi?pfd=../$relativer_pfad&details=$details'\n".
            "STYLE='text-decoration:none'><FONT COLOR='$farbe_link_leiste'>Voll-Zugang</FONT></A>\n".
            "&nbsp;&nbsp;&nbsp;&nbsp;";
  }
  else
  { $schr = ""; }

print "Content-type: text/html\n\n";
print <<"LABEL_SEITE";

<HTML><HEAD><TITLE>Ibyco: $_titel_{' verz06641431691'}</TITLE></HEAD>
<SCRIPT LANGUAGE="JavaScript">
 window.name="Show_Fenster";
</SCRIPT>
<BODY LINK="$farbe_link" VLINK="$farbe_vlink" ALINK="$farbe_alink"><A NAME="top">
<FONT FACE="Arial,Helvetica" SIZE="-1">

<CENTER>
<TABLE WIDTH="95%" BORDER="0" CELLPADDING="3" CELLSPACING="0" BGCOLOR="$farbe_leiste">
<TD ALIGN="left" WIDTH="25%">$hinauf</TD>
<TD ALIGN="right" WIDTH="75%"><FONT FACE="Arial,Helvetica" SIZE="-1">
   <NOBR>
   $schr
   <A HREF="javascript:
   hilfe = window.open('hilfe_read.html','Fenster_hilfe_read','width=580,height=435,resizable=yes,status=no,menubar=yes,scrollbars=yes,location=no');
   hilfe.focus();" STYLE='text-decoration:none'><FONT COLOR="$farbe_link_leiste">Hilfe</FONT></A></NOBR>   
   </FONT>
</TD></TABLE>
<BR>
<FONT SIZE="+0"><B>$_titel_{' verz06641431691'}</B></FONT> <BR><BR> $url/</CENTER><BR>

<CENTER><TABLE WIDTH="95%" BORDER="0" CELLPADDING="1" CELLSPACING="2">
LABEL_SEITE

# WIDTHs der TDs:
if ($details ne "0")
{ $t1 = "25%";
  $t2 = "50%";
  $t4 = "10%";
  $t5 = "5%";
  $t6 = "10%"; }
else
{ $t1 = "30%";
  $t2 = "70%";
}

# DIE FILES UND VERZEICHNISSE

# zunchst ordnen: zuerst die Verzeichnisse, dann die Dateien, jeweils alphabetisch

foreach $j (@filenamen)
{
  if ((-d "$relativer_pfad/$j") && (!($j =~ m/^\./))) 
                     # Systemdateien (die mit einem Punkt beginnen) nicht anzeigen!!!
  { push(@allenamen,$j); }                           # Verzeichnisse
  elsif ((-f "$relativer_pfad/$j") && (!($j =~ m/^\./))) 
  { push(@dateinamen,$j); }                          # Dateien
}
@allenamen = sort (@allenamen); 
@dateinamen = sort (@dateinamen); 
foreach $j (@dateinamen) { push(@allenamen,$j); }


foreach $j (@allenamen)    # Systemdateien (die mit einem Punkt beginnen) wurden oben ausgeschlossen
{
   # Name:
   # ----
   # falls Verzeichnis:
   if (-d "$relativer_pfad/$j") { $verzbild = "<IMG SRC='verz.gif' BORDER='0' WIDTH='15' HEIGHT='13'>&nbsp;";
                                  $link = "$scriptverzeichnis/read.cgi?pfd=../$relativer_pfad/$j&details=$details"; 
	                                opendir(VERZ,"$relativer_pfad/$j");
		                        @filenamen_v = readdir(VERZ);
                                        closedir(VERZ);	
		                        # Ein Sternchen fr ein leeres Verzeichnis
		                        $leer ="<FONT COLOR='$farbe_link_leiste'>*</FONT>";
		                        foreach $fl_v (@filenamen_v)
		                        {                          # Wenn es nicht nur diese Unix-Eintragungen gibt,
		                          if (!(($fl_v eq ".") || ($fl_v eq "..") 
		                             || ($fl_v eq ".06641431691") || ($fl_v eq ".top06641431691") 
				    	             || ($fl_v eq ".htaccess"))) 
		                             { $leer = ""; }          # wird das Verzeichnis als nicht-leer deklariert
		                         }								  
                                }
   # falls Datei:
   else { $verzbild = ""; 
	      $link = "$url/$j"; 
          $leer = "";            # gar keine Anzeige fr Dateien	    }
        }
   print "<TR><TD WIDTH='$t1' ALIGN='left' BGCOLOR='$farbe_leiste'>&nbsp;&nbsp;<FONT FACE='Arial,Helvetica' SIZE='-1'\n";
   print "><A HREF='$link' STYLE='text-decoration:none'\n";
   print ">$verzbild</A><A HREF='$link'>$j</A>$leer</FONT></TD>\n"; 

   # Titel:
   # -----
   $titel = $_titel_{"$j"};   # wird von .06641431691 bernommen
   print "<TD WIDTH='$t2' ALIGN='left' BGCOLOR='$farbe_leiste'><TABLE BORDER='0' CELLPADDING='0' CELLSPACING='0'\n";
   print "><TD>&nbsp;&nbsp;</TD><TD><FONT FACE='Arial,Helvetica' SIZE='-1'\n";
   print ">$titel</FONT></TD></TABLE></TD>\n";                

if ($details ne "0")
{
   # Dateigre in Byte:
   # ------------------
   $eintr = (stat("$relativer_pfad/$j"))[7]; # Filegre
   print "<TD  WIDTH='$t4' ALIGN='right' BGCOLOR='$farbe_leiste'><FONT FACE='Arial,Helvetica' SIZE='-1'\n";
   print ">&nbsp;$eintr&nbsp;Byte&nbsp;</FONT></TD>\n";  

   # Dateityp:
   # --------
   if (-T "$relativer_pfad/$j")   # falls Text-Datei
   {    if ($j =~ m/\.html$/i || $j =~ m/\.htm$/i || $j =~ m/\.shtml$/i) { $eintr = "HTML" ; }
        elsif ($j =~ m/\.cgi$/i || $j =~ m/\.pl$/i || $j =~ m/\.js$/i) { $eintr = "Script" ; }
		elsif ($j =~ m/\.ps$/i)  { $eintr = "PS" ; }		
		elsif ($j =~ m/\.java$/i) { $eintr = "Java" ; }
        else { $eintr = "Text"; } 
   }
   else    # falls Binr-Datei
   { 
        if ($j =~ m/\.gif$/i || $j =~ m/\.jpg$/i || $j =~ m/\.jpeg$/i
		|| $j =~ m/\.tif$/i || $j =~ m/\.tiff$/i || $j =~ m/\.bmp$/i) { $eintr = "Bild" ; }
        elsif ($j =~ m/\.doc$/i || $j =~ m/\.rtf$/i)  { $eintr = "Word" ; }
        elsif ($j =~ m/\.xls$/i)  { $eintr = "Excel" ; }
        elsif ($j =~ m/\.ppt$/i)  { $eintr = "PowerPoint" ; }
		elsif ($j =~ m/\.pdf$/i)  { $eintr = "PDF" ; }
        elsif ($j =~ m/\.mpeg$/i) { $eintr = "Video" ; }
        elsif ($j =~ m/\.zip$/i)  { $eintr = "ZIP" ; }
        elsif ($j =~ m/\.exe$/i)  { $eintr = "EXE" ; }
        elsif ($j =~ m/\.class$/i || $j =~ m/\.jar$/i)  { $eintr = "Java" ; }
		elsif (-d "$relativer_pfad/$j") { $eintr = "Verz" ; }
        else { $eintr = "bin"; }
   }
   print "<TD WIDTH='$t5' ALIGN='left' BGCOLOR='$farbe_leiste'><FONT FACE='Arial,Helvetica' SIZE='-1'\n";
   print ">&nbsp;$eintr&nbsp;</FONT></TD>\n";       


   # mtime (last modified time) des Files:
   # ------------------------------------
   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime((stat("$relativer_pfad/$j"))[9]);
   $jahr = $year - 100;
   if ($jahr<10) { $jahr = "0$jahr"; }
   @months = (1,2,3,4,5,6,7,8,9,10,11,12);
   if ($months[$mon]<10) {$months[$mon] = "0$months[$mon]"; }
   if ($mday<10) {$mday = "0$mday"; }
   if ($hour<10) {$hour = "0$hour"; }
   if ($min<10) {$min = "0$min"; }   
   $eintr = "$mday.$months[$mon].$jahr&nbsp;$hour:$min";

   print "<TD WIDTH='$t6' ALIGN='right' BGCOLOR='$farbe_leiste'><FONT FACE='Arial,Helvetica' SIZE='-1'\n";
   print ">&nbsp;$eintr&nbsp;</FONT></TD>\n";  
}
   print "</TR>\n";

}

print "</TABLE>\n<BR>"; 


if (@allenamen eq 0) # d.h. keine Dateien + Verzeichnisse (auer den Berechtigungs-Dateien)
{     print "<CENTER><B>Derzeit befinden sich keine Objekte in diesem Verzeichnis.</B></CENTER><BR><BR>";  }

print "<TABLE WIDTH='95%' BORDER='0' CELLPADDING='3' CELLSPACING='0' BGCOLOR='$farbe_leiste'>";

if ($details eq "0")
{ $det = "<A HREF='$scriptverzeichnis/read.cgi?pfd=../$relativer_pfad&details=1'\n".
         "STYLE='text-decoration:none'><FONT COLOR='$farbe_link_leiste'>Details anzeigen</FONT></A>"; }
else
{ $det = "<A HREF='$scriptverzeichnis/read.cgi?pfd=../$relativer_pfad&details=0'\n".
         "STYLE='text-decoration:none'><FONT COLOR='$farbe_link_leiste'>Details verstecken</FONT></A>"; }

   print "<TD ALIGN='right'>\n";
   print "<FONT FACE='Arial,Helvetica' SIZE='-1'><NOBR>\n";
   print "&nbsp;&nbsp;&nbsp;&nbsp;\n";       
   $allez = "<A HREF=\"javascript:\n".
   "allez = window.open('$scriptverzeichnis/inhalt.cgi?pfd=../$relativer_pfad&details=$details&from=read','Fenster_allez','width=240,height=400,resizable=yes,status=no,menubar=no,scrollbars=yes,location=no');\n".
   "allez.focus();\" STYLE='text-decoration:none'><FONT COLOR='$farbe_link_leiste'>Alle zeigen</FONT></A>\n";	 
   print $allez;
   print "&nbsp;&nbsp;&nbsp;&nbsp;\n$det\n&nbsp;&nbsp;\n";   

print "</NOBR></FONT></TD></TABLE>";
print "</CENTER>\n</FONT>\n</BODY>\n</HTML>";


# ----------------------------------------------------------------------------------------


sub entf
{
    # Strukturen vom Typ /A/.. aus URLs entfernen
    @teile = split(/\//,$_[0]);
    for ($i=0; $i<@teile; $i++)
    {
         if ($teile[$i] eq "..")
   	  {
   	     $teile[$i] = "";
   	     $kindex = 1;
	     while (($teile[$i-$kindex] eq "") && ($i-$kindex>1))  # letzteres verhindert Endlosschleife
	     { 
	       $kindex = $kindex + 1;   # Index des letzten nichtleeren Teils
	     }
	     $teile[$i-$kindex] = "";  # den letzten Teil, der nicht leer ist, entfernen,
	                               # um auch Strukturen wie A/../../B zu erfassen
	  }
    }
    $url_aux="";
    foreach $k (@teile)  { $url_aux = "$url_aux/$k"; }
    $url_aux =~ s/\/http/http/;
    while ($url_aux =~ /\/\//)
    { $url_aux =~ s/\/\//\//; }    # Mehrfach-Slashes entfernen
    $url_aux =~ s/http:\//http:\/\//;
    return $url_aux;
}
